module Hat.Control.Monad
  (MonadPlus(gmzero,gmplus,smzero,smplus),gjoin,ajoin,hjoin,gguard,aguard,hguard
    ,gwhen,awhen,hwhen,gunless,aunless,hunless,gap,gmsum,amsum,hmsum,gfilterM
    ,afilterM,hfilterM,gmapAndUnzipM,amapAndUnzipM,hmapAndUnzipM,gzipWithM
    ,azipWithM,hzipWithM,gzipWithM_,azipWithM_,hzipWithM_,gfoldM,afoldM,hfoldM
    ,gfoldM_,afoldM_,hfoldM_,gliftM,aliftM,hliftM,gliftM2,aliftM2,hliftM2
    ,gliftM3,aliftM3,hliftM3,gliftM4,aliftM4,hliftM4,gliftM5,aliftM5,hliftM5
    ,Monad((!>>=),(!>>),greturn,gfail,(|>>=),(|>>),sreturn,sfail),Functor(gfmap
      ,sfmap),gmapM,amapM,hmapM,gmapM_,amapM_,hmapM_,gsequence,gsequence_
    ,greplicateM,areplicateM,hreplicateM,greplicateM_,areplicateM_,hreplicateM_
    ,(!=<<),(+=<<),(*=<<)) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Data.Maybe 
import Hat.Monad 

gfoldM_ ::
  Monad m =>
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun a (T.Fun b (m a)))
          (T.Fun a (T.Fun (T.List b) (m T.Tuple0))))

hfoldM_ ::
  Monad m =>
  (T.R (T.Fun a (T.Fun b (m a)))) ->
    (T.R a) -> (T.R (T.List b)) -> T.RefExp -> T.R (m T.Tuple0)

gfoldM_ pfoldM_ p = T.ufun3 afoldM_ pfoldM_ p hfoldM_

hfoldM_ ff fa fxs p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>> p)
    (T.uwrapForward p (hfoldM ff fa fxs p))
    (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
      (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0))

greplicateM ::
  Monad m =>
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Int (T.Fun (m a) (m (T.List a))))

hreplicateM ::
  Monad m => (T.R Int) -> (T.R (m a)) -> T.RefExp -> T.R (m (T.List a))

greplicateM preplicateM p = T.ufun2 areplicateM preplicateM p hreplicateM

hreplicateM fn fx p =
  T.uap1 T.mkNoSrcPos p (gsequence T.mkNoSrcPos p)
    (T.uwrapForward p (hreplicate fn fx p))

greplicateM_ ::
  Monad m =>
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Int (T.Fun (m a) (m T.Tuple0)))

hreplicateM_ ::
  Monad m => (T.R Int) -> (T.R (m a)) -> T.RefExp -> T.R (m T.Tuple0)

greplicateM_ preplicateM_ p = T.ufun2 areplicateM_ preplicateM_ p hreplicateM_

hreplicateM_ fn fx p =
  T.uap1 T.mkNoSrcPos p (gsequence_ T.mkNoSrcPos p)
    (T.uwrapForward p (hreplicate fn fx p))

tControl_Monad = T.mkModule "Control.Monad" "Control/Monad.hs" Prelude.False

afoldM_ = T.mkVariable tControl_Monad 430001 430046 3 3 "foldM_" Prelude.False

areplicateM =
  T.mkVariable tControl_Monad 460001 460043 3 2 "replicateM" Prelude.False

areplicateM_ =
  T.mkVariable tControl_Monad 490001 490044 3 2 "replicateM_" Prelude.False
