module Hat.Control.Monad.RWS
  (RWS(RWS,brunRWS),aRWS,grunRWS,hrunRWS,arunRWS,gevalRWS,aevalRWS,hevalRWS
    ,gexecRWS,aexecRWS,hexecRWS,gmapRWS,amapRWS,hmapRWS,gwithRWS,awithRWS
    ,hwithRWS,RWST(RWST,brunRWST),aRWST,grunRWST,hrunRWST,arunRWST,gevalRWST
    ,aevalRWST,hevalRWST,gexecRWST,aexecRWST,hexecRWST,gmapRWST,amapRWST
    ,hmapRWST,gwithRWST,awithRWST,hwithRWST,module Hat.Control.Monad.Reader
    ,module Hat.Control.Monad.Writer,module Hat.Control.Monad.State) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Control.Monad 
import Hat.Control.Monad.Fix 
import Hat.Control.Monad.Trans 
import Hat.Control.Monad.Reader 
import Hat.Control.Monad.Writer 
import Hat.Control.Monad.State 
import Hat.Data.Monoid 

newtype RWS r w s a = RWS {brunRWS :: T.R (T.Fun r (T.Fun s (T.Tuple3 a s w)))}

instance T.WrapVal ((RWS r w s a))
  where
  
  wrapVal pwrapVal (kwrapVal@(RWS (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aRWS z1wrapVal)
  

grunRWS prunRWS p = T.ufun1 arunRWS prunRWS p hrunRWS

hrunRWS (T.R z1runRWS _) p = T.projection T.mkNoSrcPos p (brunRWS z1runRWS)

instance Functor ((RWS r w s))
  where
  
  gfmap pfmap p =
    T.ufun2 a50v9v52v31fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                let
                  ga pa p = T.uconstUse pa p sa
                  gs' pa p = T.uconstUse pa p ss'
                  gw pa p = T.uconstUse pa p sw
                  j51v17v51v26a =
                    case
                      T.uap3 T.mkNoSrcPos p (grunRWS T.mkNoSrcPos p) fm fr fs of
                      T.R (T.Tuple3 fa fs' fw) ka -> (ka,fa,fs',fw)
                      _ -> T.fatal p
                  sa =
                    T.uconstDef p a51v18v51v18a
                      (\ _ -> case j51v17v51v26a of (ka,fa,fs',fw) -> fa)
                  ss' =
                    T.uconstDef p a51v21v51v22s'
                      (\ _ -> case j51v17v51v26a of (ka,fa,fs',fw) -> fs')
                  sw =
                    T.uconstDef p a51v25v51v25w
                      (\ _ -> case j51v17v51v26a of (ka,fa,fs',fw) -> fw) in
                  (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
                    (T.uap1 T.mkNoSrcPos p ff (ga T.mkNoSrcPos p))
                    (gs' T.mkNoSrcPos p) (gw T.mkNoSrcPos p))))) p)
    
  

instance Monoid w => Monad ((RWS r w s))
  where
  
  greturn preturn p =
    T.ufun1 a55v9v55v47return preturn p hreturn
    where
    
    hreturn fa p =
      T.uwrapForward p
        (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ _ fs p ->
                T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 fa fs
                  (gmempty T.mkNoSrcPos p)))) p)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+*+=##=*+=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                let
                  ga pa p = T.uconstUse pa p sa
                  gs' pa p = T.uconstUse pa p ss'
                  gw pa p = T.uconstUse pa p sw
                  j57v17v57v27a =
                    case
                      T.uap3 T.mkNoSrcPos p (grunRWS T.mkNoSrcPos p) fm fr fs of
                      T.R (T.Tuple3 fa fs' fw) ka -> (ka,fa,fs',fw)
                      _ -> T.fatal p
                  sa =
                    T.uconstDef p a57v18v57v18a
                      (\ _ -> case j57v17v57v27a of (ka,fa,fs',fw) -> fa)
                  ss' =
                    T.uconstDef p a57v21v57v22s'
                      (\ _ -> case j57v17v57v27a of (ka,fa,fs',fw) -> fs')
                  sw =
                    T.uconstDef p a57v26v57v26w
                      (\ _ -> case j57v17v57v27a of (ka,fa,fs',fw) -> fw)
                  gb pb p = T.uconstUse pb p sb
                  gs'' pb p = T.uconstUse pb p ss''
                  gw' pb p = T.uconstUse pb p sw'
                  j58v17v58v28b =
                    case
                      T.uap3 T.mkNoSrcPos p (grunRWS T.mkNoSrcPos p)
                        (T.uap1 T.mkNoSrcPos p fk (ga T.mkNoSrcPos p)) fr
                        (gs' T.mkNoSrcPos p) of
                      T.R (T.Tuple3 fb fs'' fw') kb -> (kb,fb,fs'',fw')
                      _ -> T.fatal p
                  sb =
                    T.uconstDef p a58v18v58v18b
                      (\ _ -> case j58v17v58v28b of (kb,fb,fs'',fw') -> fb)
                  ss'' =
                    T.uconstDef p a58v21v58v23s''
                      (\ _ -> case j58v17v58v28b of (kb,fb,fs'',fw') -> fs'')
                  sw' =
                    T.uconstDef p a58v26v58v27w'
                      (\ _ -> case j58v17v58v28b of (kb,fb,fs'',fw') -> fw') in
                  (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 (gb T.mkNoSrcPos p)
                    (gs'' T.mkNoSrcPos p)
                    (T.uap2 T.mkNoSrcPos p (gmappend T.mkNoSrcPos p)
                      (gw T.mkNoSrcPos p) (gw' T.mkNoSrcPos p)))))) p)
    
  

instance Monoid w => MonadFix ((RWS r w s))
  where
  
  gmfix pmfix p =
    T.ufun1 a62v9v62v78mfix pmfix p hmfix
    where
    
    hmfix ff p =
      T.uwrapForward p
        (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                let
                  ga pa p = T.uconstUse pa p sa
                  gs' pa p = T.uconstUse pa p ss'
                  gw pa p = T.uconstUse pa p sw
                  j62v36v62v45a =
                    case
                      T.uap3 T.mkNoSrcPos p (grunRWS T.mkNoSrcPos p)
                        (T.uap1 T.mkNoSrcPos p ff (ga T.mkNoSrcPos p)) fr fs of
                      T.R (T.Tuple3 fa fs' fw) ka -> (ka,fa,fs',fw)
                      _ -> T.fatal p
                  sa =
                    T.uconstDef p a62v37v62v37a
                      (\ _ -> case j62v36v62v45a of (ka,fa,fs',fw) -> fa)
                  ss' =
                    T.uconstDef p a62v40v62v41s'
                      (\ _ -> case j62v36v62v45a of (ka,fa,fs',fw) -> fs')
                  sw =
                    T.uconstDef p a62v44v62v44w
                      (\ _ -> case j62v36v62v45a of (ka,fa,fs',fw) -> fw) in
                  (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 (ga T.mkNoSrcPos p)
                    (gs' T.mkNoSrcPos p) (gw T.mkNoSrcPos p))))) p)
    
  

instance Monoid w => MonadReader (r) ((RWS r w s))
  where
  
  gask pask p = T.uconstUse pask p sask
  
  sask =
    T.uconstDef T.mkRoot a65v9v65v48ask
      (\ p ->
        T.uwrapForward p
          (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
              *$
              (T.ufun2 T.mkLambda T.mkNoSrcPos p
                (\ fr fs p ->
                  T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 fr fs
                    (gmempty T.mkNoSrcPos p)))) p))
  
  glocal plocal p =
    T.ufun2 a66v9v66v50local plocal p hlocal
    where
    
    hlocal ff fm p =
      T.uwrapForward p
        (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                T.uap3 T.mkNoSrcPos p (grunRWS T.mkNoSrcPos p) fm
                  (T.uap1 T.mkNoSrcPos p ff fr) fs))) p)
    
  

instance Monoid w => MonadWriter (w) ((RWS r w s))
  where
  
  gtell ptell p =
    T.ufun1 a69v9v69v44tell ptell p htell
    where
    
    htell fw p =
      T.uwrapForward p
        (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ _ fs p ->
                T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
                  (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0) fs fw))) p)
    
  
  glisten plisten p =
    T.ufun1 a70v9v72v34listen plisten p hlisten
    where
    
    hlisten fm p =
      T.uwrapForward p
        (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                let
                  ga pa p = T.uconstUse pa p sa
                  gs' pa p = T.uconstUse pa p ss'
                  gw pa p = T.uconstUse pa p sw
                  j71v17v71v26a =
                    case
                      T.uap3 T.mkNoSrcPos p (grunRWS T.mkNoSrcPos p) fm fr fs of
                      T.R (T.Tuple3 fa fs' fw) ka -> (ka,fa,fs',fw)
                      _ -> T.fatal p
                  sa =
                    T.uconstDef p a71v18v71v18a
                      (\ _ -> case j71v17v71v26a of (ka,fa,fs',fw) -> fa)
                  ss' =
                    T.uconstDef p a71v21v71v22s'
                      (\ _ -> case j71v17v71v26a of (ka,fa,fs',fw) -> fs')
                  sw =
                    T.uconstDef p a71v25v71v25w
                      (\ _ -> case j71v17v71v26a of (ka,fa,fs',fw) -> fw) in
                  (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
                    (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                      (ga T.mkNoSrcPos p) (gw T.mkNoSrcPos p))
                    (gs' T.mkNoSrcPos p) (gw T.mkNoSrcPos p))))) p)
    
  
  gpass ppass p =
    T.ufun1 a73v9v75v31pass ppass p hpass
    where
    
    hpass fm p =
      T.uwrapForward p
        (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                let
                  ga pa p = T.uconstUse pa p sa
                  gf pa p = T.uconstUse pa p sf
                  gs' pa p = T.uconstUse pa p ss'
                  gw pa p = T.uconstUse pa p sw
                  j74v17v74v31a =
                    case
                      T.uap3 T.mkNoSrcPos p (grunRWS T.mkNoSrcPos p) fm fr fs of
                      T.R (T.Tuple3 (T.R (T.Tuple2 fa ff) _) fs' fw) ka ->
                        (ka,fa,ff,fs',fw)
                      _ -> T.fatal p
                  sa =
                    T.uconstDef p a74v19v74v19a
                      (\ _ -> case j74v17v74v31a of (ka,fa,ff,fs',fw) -> fa)
                  sf =
                    T.uconstDef p a74v22v74v22f
                      (\ _ -> case j74v17v74v31a of (ka,fa,ff,fs',fw) -> ff)
                  ss' =
                    T.uconstDef p a74v26v74v27s'
                      (\ _ -> case j74v17v74v31a of (ka,fa,ff,fs',fw) -> fs')
                  sw =
                    T.uconstDef p a74v30v74v30w
                      (\ _ -> case j74v17v74v31a of (ka,fa,ff,fs',fw) -> fw) in
                  (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 (ga T.mkNoSrcPos p)
                    (gs' T.mkNoSrcPos p)
                    (T.uap1 T.mkNoSrcPos p (gf T.mkNoSrcPos p)
                      (gw T.mkNoSrcPos p)))))) p)
    
  

instance Monoid w => MonadState (s) ((RWS r w s))
  where
  
  gget pget p = T.uconstUse pget p sget
  
  sget =
    T.uconstDef T.mkRoot a78v9v78v44get
      (\ p ->
        T.uwrapForward p
          (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
              *$
              (T.ufun2 T.mkLambda T.mkNoSrcPos p
                (\ _ fs p ->
                  T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 fs fs
                    (gmempty T.mkNoSrcPos p)))) p))
  
  gput pput p =
    T.ufun1 a79v9v79v46put pput p hput
    where
    
    hput fs p =
      T.uwrapForward p
        (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ _ _ p ->
                T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
                  (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0) fs
                  (gmempty T.mkNoSrcPos p)))) p)
    
  

gevalRWS ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (RWS r w s a) (T.Fun r (T.Fun s (T.Tuple2 a w))))

hevalRWS ::
  (T.R (RWS r w s a)) -> (T.R r) -> (T.R s) -> T.RefExp -> T.R (T.Tuple2 a w)

gevalRWS pevalRWS p = T.ufun3 aevalRWS pevalRWS p hevalRWS

hevalRWS fm fr fs p =
  let
    ga pa p = T.uconstUse pa p sa
    gw pa p = T.uconstUse pa p sw
    j84v5v84v13a =
      case T.uap3 T.mkNoSrcPos p (grunRWS T.mkNoSrcPos p) fm fr fs of
        T.R (T.Tuple3 fa _ fw) ka -> (ka,fa,fw)
        _ -> T.fatal p
    sa =
      T.uconstDef p a84v6v84v6a (\ _ -> case j84v5v84v13a of (ka,fa,fw) -> fa)
    sw =
      T.uconstDef p a84v12v84v12w (\ _ -> case j84v5v84v13a of (ka,fa,fw) -> fw)
    in
    (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (ga T.mkNoSrcPos p)
      (gw T.mkNoSrcPos p))

gexecRWS ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (RWS r w s a) (T.Fun r (T.Fun s (T.Tuple2 s w))))

hexecRWS ::
  (T.R (RWS r w s a)) -> (T.R r) -> (T.R s) -> T.RefExp -> T.R (T.Tuple2 s w)

gexecRWS pexecRWS p = T.ufun3 aexecRWS pexecRWS p hexecRWS

hexecRWS fm fr fs p =
  let
    gs' ps' p = T.uconstUse ps' p ss'
    gw ps' p = T.uconstUse ps' p sw
    j89v5v89v14s' =
      case T.uap3 T.mkNoSrcPos p (grunRWS T.mkNoSrcPos p) fm fr fs of
        T.R (T.Tuple3 _ fs' fw) ks' -> (ks',fs',fw)
        _ -> T.fatal p
    ss' =
      T.uconstDef p a89v9v89v10s'
        (\ _ -> case j89v5v89v14s' of (ks',fs',fw) -> fs')
    sw =
      T.uconstDef p a89v13v89v13w
        (\ _ -> case j89v5v89v14s' of (ks',fs',fw) -> fw) in
    (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (gs' T.mkNoSrcPos p)
      (gw T.mkNoSrcPos p))

gmapRWS ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (T.Tuple3 a s w) (T.Tuple3 b s w'))
          (T.Fun (RWS r w s a) (RWS r w' s b)))

hmapRWS ::
  (T.R (T.Fun (T.Tuple3 a s w) (T.Tuple3 b s w'))) ->
    (T.R (RWS r w s a)) -> T.RefExp -> T.R (RWS r w' s b)

gmapRWS pmapRWS p = T.ufun2 amapRWS pmapRWS p hmapRWS

hmapRWS ff fm p =
  T.uwrapForward p
    (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
        *$
        (T.ufun2 T.mkLambda T.mkNoSrcPos p
          (\ fr fs p ->
            T.uap1 T.mkNoSrcPos p ff
              (T.uap3 T.mkNoSrcPos p (grunRWS T.mkNoSrcPos p) fm fr fs)))) p)

gwithRWS ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun r' (T.Fun s (T.Tuple2 r s)))
          (T.Fun (RWS r w s a) (RWS r' w s a)))

hwithRWS ::
  (T.R (T.Fun r' (T.Fun s (T.Tuple2 r s)))) ->
    (T.R (RWS r w s a)) -> T.RefExp -> T.R (RWS r' w s a)

gwithRWS pwithRWS p = T.ufun2 awithRWS pwithRWS p hwithRWS

hwithRWS ff fm p =
  T.uwrapForward p
    (((T.pa0 RWS T.cn1 T.mkNoSrcPos p aRWS)
        *$
        (T.ufun2 T.mkLambda T.mkNoSrcPos p
          (\ fr fs p ->
            T.uwrapForward p
              (huncurry (T.uwrapForward p (hrunRWS fm p))
                (T.uap2 T.mkNoSrcPos p ff fr fs) p)))) p)

newtype RWST r w s m a =
  RWST {brunRWST :: T.R (T.Fun r (T.Fun s (m (T.Tuple3 a s w))))}

instance T.WrapVal ((RWST r w s m a))
  where
  
  wrapVal pwrapVal (kwrapVal@(RWST (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aRWST z1wrapVal)
  

grunRWST prunRWST p = T.ufun1 arunRWST prunRWST p hrunRWST

hrunRWST (T.R z1runRWST _) p = T.projection T.mkNoSrcPos p (brunRWST z1runRWST)

instance Monad m => Functor ((RWST r w s m))
  where
  
  gfmap pfmap p =
    T.ufun2 a102v9v104v35fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fm fr fs)
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fv103v31v103v43v1 p ->
                      T.uccase T.mkNoSrcPos p
                        (let
                          v103v31v103v43v1 (T.R (T.Tuple3 fa fs' fw) _) p =
                            T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                              (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
                                (T.uap1 T.mkNoSrcPos p ff fa) fs' fw)
                          v103v31v103v43v1 _ p =
                            T.uap1 T.mkNoSrcPos p
                              (Hat.Prelude.gfail T.mkNoSrcPos p)
                              (T.fromLitString T.mkNoSrcPos p
                                "pattern-match failure in do expression") in
                          (v103v31v103v43v1)) fv103v31v103v43v1))))) p)
    
  

instance (Monoid w,Monad m) => Monad ((RWST r w s m))
  where
  
  greturn preturn p =
    T.ufun1 a107v9v107v55return preturn p hreturn
    where
    
    hreturn fa p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ _ fs p ->
                T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                  (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 fa fs
                    (gmempty T.mkNoSrcPos p))))) p)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+#!@=##=#!@=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fm fr fs)
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fv109v32v109v44v1 p ->
                      T.uccase T.mkNoSrcPos p
                        (let
                          v109v32v109v44v1 (T.R (T.Tuple3 fa fs' fw) _) p =
                            T.uap2 T.mkNoSrcPos p
                              (T.mkNoSrcPos Hat.Prelude.!>>= p)
                              (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p)
                                (T.uap1 T.mkNoSrcPos p fk fa) fr fs')
                              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                                (\ fv110v32v110v49v1 p ->
                                  T.uccase T.mkNoSrcPos p
                                    (let
                                      v110v32v110v49v1
                                        (T.R (T.Tuple3 fb fs'' fw') _) p =
                                        T.uap1 T.mkNoSrcPos p
                                          (greturn T.mkNoSrcPos p)
                                          (T.con3 T.mkNoSrcPos p T.Tuple3
                                            T.aTuple3 fb fs''
                                            (T.uap2 T.mkNoSrcPos p
                                              (gmappend T.mkNoSrcPos p) fw fw'))
                                      v110v32v110v49v1 _ p =
                                        T.uap1 T.mkNoSrcPos p
                                          (Hat.Prelude.gfail T.mkNoSrcPos p)
                                          (T.fromLitString T.mkNoSrcPos p
                                            "pattern-match failure in do expression")
                                      in (v110v32v110v49v1)) fv110v32v110v49v1))
                          v109v32v109v44v1 _ p =
                            T.uap1 T.mkNoSrcPos p
                              (Hat.Prelude.gfail T.mkNoSrcPos p)
                              (T.fromLitString T.mkNoSrcPos p
                                "pattern-match failure in do expression") in
                          (v109v32v109v44v1)) fv109v32v109v44v1))))) p)
    
  
  gfail pfail p =
    T.ufun1 a112v9v112v42fail pfail p hfail
    where
    
    hfail fmsg p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ _ _ p -> T.uap1 T.mkNoSrcPos p (gfail T.mkNoSrcPos p) fmsg)))
          p)
    
  

instance (Monoid w,MonadPlus m) => MonadPlus ((RWST r w s m))
  where
  
  gmzero pmzero p = T.uconstUse pmzero p smzero
  
  smzero =
    T.uconstDef T.mkRoot a115v9v115v42mzero
      (\ p ->
        T.uwrapForward p
          (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
              *$
              (T.ufun2 T.mkLambda T.mkNoSrcPos p
                (\ _ _ p -> gmzero T.mkNoSrcPos p))) p))
  
  gmplus pmplus p =
    T.ufun2 a116v12v116v16mplus pmplus p hmplus
    where
    
    hmplus fm fn p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                T.uap2 T.mkNoSrcPos p (gmplus T.mkNoSrcPos p)
                  (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fm fr fs)
                  (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fn fr fs))))
          p)
    
  

instance (Monoid w,MonadFix m) => MonadFix ((RWST r w s m))
  where
  
  gmfix pmfix p =
    T.ufun1 a119v9v119v72mfix pmfix p hmfix
    where
    
    hmfix ff p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                T.uwrapForward p
                  (((gmfix T.mkNoSrcPos p)
                      *$
                      (T.ufun1 T.mkLambda T.mkNoSrcPos p
                        (\ (T.R ~(T.Tuple3 fa _ _) _) p ->
                          let
                            ga pa p = T.uconstUse pa p sa
                            sa =
                              T.uconstDef p a0v0v0v0a
                                (\ p -> T.projection T.mkNoSrcPos p fa) in
                            (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p)
                              (T.uap1 T.mkNoSrcPos p ff (ga T.mkNoSrcPos p)) fr
                              fs)))) p)))) p)
    
  

instance (Monoid w,Monad m) => MonadReader (r) ((RWST r w s m))
  where
  
  gask pask p = T.uconstUse pask p sask
  
  sask =
    T.uconstDef T.mkRoot a122v9v122v56ask
      (\ p ->
        T.uwrapForward p
          (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
              *$
              (T.ufun2 T.mkLambda T.mkNoSrcPos p
                (\ fr fs p ->
                  T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                    (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 fr fs
                      (gmempty T.mkNoSrcPos p))))) p))
  
  glocal plocal p =
    T.ufun2 a123v9v123v52local plocal p hlocal
    where
    
    hlocal ff fm p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fm
                  (T.uap1 T.mkNoSrcPos p ff fr) fs))) p)
    
  

instance (Monoid w,Monad m) => MonadWriter (w) ((RWST r w s m))
  where
  
  gtell ptell p =
    T.ufun1 a126v9v126v50tell ptell p htell
    where
    
    htell fw p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ _ fs p ->
                T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                  (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
                    (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0) fs fw)))) p)
    
  
  glisten plisten p =
    T.ufun1 a127v9v129v38listen plisten p hlisten
    where
    
    hlisten fm p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fm fr fs)
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fv128v31v128v43v1 p ->
                      T.uccase T.mkNoSrcPos p
                        (let
                          v128v31v128v43v1 (T.R (T.Tuple3 fa fs' fw) _) p =
                            T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                              (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
                                (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa fw)
                                fs' fw)
                          v128v31v128v43v1 _ p =
                            T.uap1 T.mkNoSrcPos p
                              (Hat.Prelude.gfail T.mkNoSrcPos p)
                              (T.fromLitString T.mkNoSrcPos p
                                "pattern-match failure in do expression") in
                          (v128v31v128v43v1)) fv128v31v128v43v1))))) p)
    
  
  gpass ppass p =
    T.ufun1 a130v9v132v35pass ppass p hpass
    where
    
    hpass fm p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fm fr fs)
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fv131v36v131v48v1 p ->
                      T.uccase T.mkNoSrcPos p
                        (let
                          v131v36v131v48v1
                            (T.R (T.Tuple3 (T.R (T.Tuple2 fa ff) _) fs' fw) _)
                            p =
                            T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                              (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 fa fs'
                                (T.uap1 T.mkNoSrcPos p ff fw))
                          v131v36v131v48v1 _ p =
                            T.uap1 T.mkNoSrcPos p
                              (Hat.Prelude.gfail T.mkNoSrcPos p)
                              (T.fromLitString T.mkNoSrcPos p
                                "pattern-match failure in do expression") in
                          (v131v36v131v48v1)) fv131v36v131v48v1))))) p)
    
  

instance (Monoid w,Monad m) => MonadState (s) ((RWST r w s m))
  where
  
  gget pget p = T.uconstUse pget p sget
  
  sget =
    T.uconstDef T.mkRoot a135v9v135v52get
      (\ p ->
        T.uwrapForward p
          (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
              *$
              (T.ufun2 T.mkLambda T.mkNoSrcPos p
                (\ _ fs p ->
                  T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                    (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 fs fs
                      (gmempty T.mkNoSrcPos p))))) p))
  
  gput pput p =
    T.ufun1 a136v9v136v54put pput p hput
    where
    
    hput fs p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ _ _ p ->
                T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                  (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
                    (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0) fs
                    (gmempty T.mkNoSrcPos p))))) p)
    
  

instance Monoid w => MonadTrans ((RWST r w s))
  where
  
  glift plift p =
    T.ufun1 a139v9v141v37lift plift p hlift
    where
    
    hlift fm p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ _ fs p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fm
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fa p ->
                      T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                        (T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 fa fs
                          (gmempty T.mkNoSrcPos p))))))) p)
    
  

instance (Monoid w,MonadIO m) => MonadIO ((RWST r w s m))
  where
  
  gliftIO pliftIO p = T.uconstUse pliftIO p sliftIO
  
  sliftIO =
    T.uconstDef T.mkRoot a144v9v144v30liftIO
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gliftIO T.mkNoSrcPos p))
  

gevalRWST ::
  Monad m =>
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (RWST r w s m a) (T.Fun r (T.Fun s (m (T.Tuple2 a w)))))

hevalRWST ::
  Monad m =>
  (T.R (RWST r w s m a)) ->
    (T.R r) -> (T.R s) -> T.RefExp -> T.R (m (T.Tuple2 a w))

gevalRWST pevalRWST p = T.ufun3 aevalRWST pevalRWST p hevalRWST

hevalRWST fm fr fs p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
    (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fm fr fs)
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fv149v18v149v30v1 p ->
        T.uccase T.mkNoSrcPos p
          (let
            v149v18v149v30v1 (T.R (T.Tuple3 fa _ fw) _) p =
              T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa fw)
            v149v18v149v30v1 _ p =
              T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                (T.fromLitString T.mkNoSrcPos p
                  "pattern-match failure in do expression") in
            (v149v18v149v30v1)) fv149v18v149v30v1))

gexecRWST ::
  Monad m =>
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (RWST r w s m a) (T.Fun r (T.Fun s (m (T.Tuple2 s w)))))

hexecRWST ::
  Monad m =>
  (T.R (RWST r w s m a)) ->
    (T.R r) -> (T.R s) -> T.RefExp -> T.R (m (T.Tuple2 s w))

gexecRWST pexecRWST p = T.ufun3 aexecRWST pexecRWST p hexecRWST

hexecRWST fm fr fs p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
    (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fm fr fs)
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fv154v19v154v31v1 p ->
        T.uccase T.mkNoSrcPos p
          (let
            v154v19v154v31v1 (T.R (T.Tuple3 _ fs' fw) _) p =
              T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fs' fw)
            v154v19v154v31v1 _ p =
              T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                (T.fromLitString T.mkNoSrcPos p
                  "pattern-match failure in do expression") in
            (v154v19v154v31v1)) fv154v19v154v31v1))

gmapRWST ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (m (T.Tuple3 a s w)) (n (T.Tuple3 b s w')))
          (T.Fun (RWST r w s m a) (RWST r w' s n b)))

hmapRWST ::
  (T.R (T.Fun (m (T.Tuple3 a s w)) (n (T.Tuple3 b s w')))) ->
    (T.R (RWST r w s m a)) -> T.RefExp -> T.R (RWST r w' s n b)

gmapRWST pmapRWST p = T.ufun2 amapRWST pmapRWST p hmapRWST

hmapRWST ff fm p =
  T.uwrapForward p
    (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
        *$
        (T.ufun2 T.mkLambda T.mkNoSrcPos p
          (\ fr fs p ->
            T.uap1 T.mkNoSrcPos p ff
              (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fm fr fs)))) p)

gwithRWST ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun r' (T.Fun s (T.Tuple2 r s)))
          (T.Fun (RWST r w s m a) (RWST r' w s m a)))

hwithRWST ::
  (T.R (T.Fun r' (T.Fun s (T.Tuple2 r s)))) ->
    (T.R (RWST r w s m a)) -> T.RefExp -> T.R (RWST r' w s m a)

gwithRWST pwithRWST p = T.ufun2 awithRWST pwithRWST p hwithRWST

hwithRWST ff fm p =
  T.uwrapForward p
    (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
        *$
        (T.ufun2 T.mkLambda T.mkNoSrcPos p
          (\ fr fs p ->
            T.uwrapForward p
              (huncurry (T.uwrapForward p (hrunRWST fm p))
                (T.uap2 T.mkNoSrcPos p ff fr fs) p)))) p)

tControl_Monad_RWS =
  T.mkModule "Control.Monad.RWS" "Control/Monad/RWS.hs" Prelude.False

aRWS =
  T.mkConstructorWFields tControl_Monad_RWS 470023 470025 3 1 "RWS"
    (arunRWS : [])

aRWST =
  T.mkConstructorWFields tControl_Monad_RWS 990026 990029 3 1 "RWST"
    (arunRWST : [])

arunRWS =
  T.mkVariable tControl_Monad_RWS 470029 470034 3 1 "runRWS" Prelude.False

a50v9v52v31fmap =
  T.mkVariable tControl_Monad_RWS 500009 520031 3 2 "fmap" Prelude.False

a55v9v55v47return =
  T.mkVariable tControl_Monad_RWS 550009 550047 3 1 "return" Prelude.False

(+*+=##=*+=#%>>=) =
  T.mkVariable tControl_Monad_RWS 560011 560013 6 2 ">>=" Prelude.False

a62v9v62v78mfix =
  T.mkVariable tControl_Monad_RWS 620009 620078 3 1 "mfix" Prelude.False

a65v9v65v48ask =
  T.mkVariable tControl_Monad_RWS 650009 650048 3 0 "ask" Prelude.False

a66v9v66v50local =
  T.mkVariable tControl_Monad_RWS 660009 660050 3 2 "local" Prelude.False

a69v9v69v44tell =
  T.mkVariable tControl_Monad_RWS 690009 690044 3 1 "tell" Prelude.False

a70v9v72v34listen =
  T.mkVariable tControl_Monad_RWS 700009 720034 3 1 "listen" Prelude.False

a73v9v75v31pass =
  T.mkVariable tControl_Monad_RWS 730009 750031 3 1 "pass" Prelude.False

a78v9v78v44get =
  T.mkVariable tControl_Monad_RWS 780009 780044 3 0 "get" Prelude.False

a79v9v79v46put =
  T.mkVariable tControl_Monad_RWS 790009 790046 3 1 "put" Prelude.False

aevalRWS =
  T.mkVariable tControl_Monad_RWS 830001 850013 3 3 "evalRWS" Prelude.False

aexecRWS =
  T.mkVariable tControl_Monad_RWS 880001 900014 3 3 "execRWS" Prelude.False

amapRWS =
  T.mkVariable tControl_Monad_RWS 930001 930042 3 2 "mapRWS" Prelude.False

awithRWS =
  T.mkVariable tControl_Monad_RWS 960001 960053 3 2 "withRWS" Prelude.False

arunRWST =
  T.mkVariable tControl_Monad_RWS 990033 990039 3 1 "runRWST" Prelude.False

a102v9v104v35fmap =
  T.mkVariable tControl_Monad_RWS 1020009 1040035 3 2 "fmap" Prelude.False

a107v9v107v55return =
  T.mkVariable tControl_Monad_RWS 1070009 1070055 3 1 "return" Prelude.False

(+#!@=##=#!@=#%>>=) =
  T.mkVariable tControl_Monad_RWS 1080011 1080013 6 2 ">>=" Prelude.False

a112v9v112v42fail =
  T.mkVariable tControl_Monad_RWS 1120009 1120042 3 1 "fail" Prelude.False

a115v9v115v42mzero =
  T.mkVariable tControl_Monad_RWS 1150009 1150042 3 0 "mzero" Prelude.False

a116v12v116v16mplus =
  T.mkVariable tControl_Monad_RWS 1160012 1160016 3 2 "mplus" Prelude.False

a119v9v119v72mfix =
  T.mkVariable tControl_Monad_RWS 1190009 1190072 3 1 "mfix" Prelude.False

a122v9v122v56ask =
  T.mkVariable tControl_Monad_RWS 1220009 1220056 3 0 "ask" Prelude.False

a123v9v123v52local =
  T.mkVariable tControl_Monad_RWS 1230009 1230052 3 2 "local" Prelude.False

a126v9v126v50tell =
  T.mkVariable tControl_Monad_RWS 1260009 1260050 3 1 "tell" Prelude.False

a127v9v129v38listen =
  T.mkVariable tControl_Monad_RWS 1270009 1290038 3 1 "listen" Prelude.False

a130v9v132v35pass =
  T.mkVariable tControl_Monad_RWS 1300009 1320035 3 1 "pass" Prelude.False

a135v9v135v52get =
  T.mkVariable tControl_Monad_RWS 1350009 1350052 3 0 "get" Prelude.False

a136v9v136v54put =
  T.mkVariable tControl_Monad_RWS 1360009 1360054 3 1 "put" Prelude.False

a139v9v141v37lift =
  T.mkVariable tControl_Monad_RWS 1390009 1410037 3 1 "lift" Prelude.False

a144v9v144v30liftIO =
  T.mkVariable tControl_Monad_RWS 1440009 1440030 3 0 "liftIO" Prelude.False

aevalRWST =
  T.mkVariable tControl_Monad_RWS 1480001 1500017 3 3 "evalRWST" Prelude.False

aexecRWST =
  T.mkVariable tControl_Monad_RWS 1530001 1550018 3 3 "execRWST" Prelude.False

amapRWST =
  T.mkVariable tControl_Monad_RWS 1580001 1580045 3 2 "mapRWST" Prelude.False

awithRWST =
  T.mkVariable tControl_Monad_RWS 1610001 1610056 3 2 "withRWST" Prelude.False

a51v18v51v18a =
  T.mkVariable tControl_Monad_RWS 510018 510018 3 0 "a" Prelude.True

a51v21v51v22s' =
  T.mkVariable tControl_Monad_RWS 510021 510022 3 0 "s'" Prelude.True

a51v25v51v25w =
  T.mkVariable tControl_Monad_RWS 510025 510025 3 0 "w" Prelude.True

a57v18v57v18a =
  T.mkVariable tControl_Monad_RWS 570018 570018 3 0 "a" Prelude.True

a57v21v57v22s' =
  T.mkVariable tControl_Monad_RWS 570021 570022 3 0 "s'" Prelude.True

a57v26v57v26w =
  T.mkVariable tControl_Monad_RWS 570026 570026 3 0 "w" Prelude.True

a58v18v58v18b =
  T.mkVariable tControl_Monad_RWS 580018 580018 3 0 "b" Prelude.True

a58v21v58v23s'' =
  T.mkVariable tControl_Monad_RWS 580021 580023 3 0 "s''" Prelude.True

a58v26v58v27w' =
  T.mkVariable tControl_Monad_RWS 580026 580027 3 0 "w'" Prelude.True

a62v37v62v37a =
  T.mkVariable tControl_Monad_RWS 620037 620037 3 0 "a" Prelude.True

a62v40v62v41s' =
  T.mkVariable tControl_Monad_RWS 620040 620041 3 0 "s'" Prelude.True

a62v44v62v44w =
  T.mkVariable tControl_Monad_RWS 620044 620044 3 0 "w" Prelude.True

a71v18v71v18a =
  T.mkVariable tControl_Monad_RWS 710018 710018 3 0 "a" Prelude.True

a71v21v71v22s' =
  T.mkVariable tControl_Monad_RWS 710021 710022 3 0 "s'" Prelude.True

a71v25v71v25w =
  T.mkVariable tControl_Monad_RWS 710025 710025 3 0 "w" Prelude.True

a74v19v74v19a =
  T.mkVariable tControl_Monad_RWS 740019 740019 3 0 "a" Prelude.True

a74v22v74v22f =
  T.mkVariable tControl_Monad_RWS 740022 740022 3 0 "f" Prelude.True

a74v26v74v27s' =
  T.mkVariable tControl_Monad_RWS 740026 740027 3 0 "s'" Prelude.True

a74v30v74v30w =
  T.mkVariable tControl_Monad_RWS 740030 740030 3 0 "w" Prelude.True

a84v6v84v6a = T.mkVariable tControl_Monad_RWS 840006 840006 3 0 "a" Prelude.True

a84v12v84v12w =
  T.mkVariable tControl_Monad_RWS 840012 840012 3 0 "w" Prelude.True

a89v9v89v10s' =
  T.mkVariable tControl_Monad_RWS 890009 890010 3 0 "s'" Prelude.True

a89v13v89v13w =
  T.mkVariable tControl_Monad_RWS 890013 890013 3 0 "w" Prelude.True

a0v0v0v0a = T.mkVariable tControl_Monad_RWS 0 0 3 0 "a" Prelude.True
