module Hat.Control.Monad.Trans (MonadTrans(..),MonadIO(..)) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.System.IO 

class MonadTrans t
  where
  
  glift :: Monad m => T.RefSrcPos -> T.RefExp -> T.R (T.Fun (m a) (t m a))
  
  slift :: Monad m => T.R (T.Fun (m a) (t m a))
  

class Monad m => MonadIO m
  where
  
  gliftIO :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (IO a) (m a))
  
  sliftIO :: T.R (T.Fun (IO a) (m a))
  

instance MonadIO (IO)
  where
  
  gliftIO pliftIO p = T.uconstUse pliftIO p sliftIO
  
  sliftIO = T.uconstDef T.mkRoot a44v9v44v19liftIO (\ p -> gid T.mkNoSrcPos p)
  

tControl_Monad_Trans =
  T.mkModule "Control.Monad.Trans" "Control/Monad/Trans.hs" Prelude.False

a44v9v44v19liftIO =
  T.mkVariable tControl_Monad_Trans 440009 440019 3 0 "liftIO" Prelude.False
