module Hat.System.IO
  (Handle(),HandlePosn(),IOMode(ReadMode,WriteMode,AppendMode,ReadWriteMode)
    ,aReadMode,aWriteMode,aAppendMode,aReadWriteMode,BufferMode(NoBuffering
      ,LineBuffering,BlockBuffering),aNoBuffering,aLineBuffering,aBlockBuffering
    ,SeekMode(AbsoluteSeek,RelativeSeek,SeekFromEnd),aAbsoluteSeek,aRelativeSeek
    ,aSeekFromEnd,gstdin,gstdout,gstderr,gopenFile,aopenFile,hopenFile,ghClose
    ,ahClose,hhClose,ghFileSize,ahFileSize,hhFileSize,ghIsEOF,ahIsEOF,hhIsEOF
    ,gisEOF,ghSetBuffering,ahSetBuffering,hhSetBuffering,ghGetBuffering
    ,ahGetBuffering,hhGetBuffering,ghFlush,ahFlush,hhFlush,ghGetPosn,ahGetPosn
    ,hhGetPosn,ghSetPosn,ahSetPosn,hhSetPosn,ghSeek,ahSeek,hhSeek,ghWaitForInput
    ,ahWaitForInput,hhWaitForInput,ghReady,ahReady,hhReady,ghGetChar,ahGetChar
    ,hhGetChar,ghGetLine,ahGetLine,hhGetLine,ghLookAhead,ahLookAhead,hhLookAhead
    ,ghGetContents,ahGetContents,hhGetContents,ghPutChar,ahPutChar,hhPutChar
    ,ghPutStr,ahPutStr,hhPutStr,ghPutStrLn,ahPutStrLn,hhPutStrLn,ghPrint,ahPrint
    ,hhPrint,ghIsOpen,ahIsOpen,hhIsOpen,ghIsClosed,ahIsClosed,hhIsClosed
    ,ghIsReadable,ahIsReadable,hhIsReadable,ghIsWritable,ahIsWritable
    ,hhIsWritable,ghIsSeekable,ahIsSeekable,hhIsSeekable,gisAlreadyExistsError
    ,aisAlreadyExistsError,hisAlreadyExistsError,gisDoesNotExistError
    ,aisDoesNotExistError,hisDoesNotExistError,gisAlreadyInUseError
    ,aisAlreadyInUseError,hisAlreadyInUseError,gisFullError,aisFullError
    ,hisFullError,gisEOFError,aisEOFError,hisEOFError,gisIllegalOperation
    ,aisIllegalOperation,hisIllegalOperation,gisPermissionError
    ,aisPermissionError,hisPermissionError,gisUserError,aisUserError
    ,hisUserError,gioeGetErrorString,aioeGetErrorString,hioeGetErrorString
    ,gioeGetHandle,aioeGetHandle,hioeGetHandle,gioeGetFileName,aioeGetFileName
    ,hioeGetFileName,gtry,atry,htry,gbracket,abracket,hbracket,gbracket_
    ,abracket_,hbracket_,IO(),FilePath(),IOError(),gioError,aioError,hioError
    ,guserError,auserError,huserError,gcatch,acatch,hcatch,ginteract,ainteract
    ,hinteract,gputChar,aputChar,hputChar,gputStr,aputStr,hputStr,gputStrLn
    ,aputStrLn,hputStrLn,gprint,aprint,hprint,ggetChar,ggetLine,ggetContents
    ,greadFile,areadFile,hreadFile,gwriteFile,awriteFile,hwriteFile,gappendFile
    ,aappendFile,happendFile,greadIO,areadIO,hreadIO,greadLn,gfixIO,afixIO
    ,hfixIO) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.IO 
import Hat.System.IO.Unsafe 

gfixIO :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun a (IO a)) (IO a))

hfixIO :: (T.R (T.Fun a (IO a))) -> T.RefExp -> T.R (IO a)

gfixIO pfixIO p = T.ufun1 afixIO pfixIO p hfixIO

hfixIO ff p =
  let
    gx px p = T.uconstUse px p sx
    sx =
      T.uconstDef p a81v23v81v46x
        (\ p ->
          T.uwrapForward p
            (hunsafePerformIO (T.uap1 T.mkNoSrcPos p ff (gx T.mkNoSrcPos p)) p))
    in (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) (gx T.mkNoSrcPos p))

tSystem_IO = T.mkModule "System.IO" "System/IO.hs" Prelude.False

afixIO = T.mkVariable tSystem_IO 810001 810059 3 1 "fixIO" Prelude.False

a81v23v81v46x = T.mkVariable tSystem_IO 810023 810046 3 0 "x" Prelude.True
