module Hat.Text.PrettyPrint.HughesPJ
  (Doc(),gempty,gsemi,gcomma,gcolon,gspace,gequals,glparen,grparen,glbrack
    ,grbrack,glbrace,grbrace,gtext,atext,htext,gchar,achar,hchar,gptext,aptext
    ,hptext,gint,aint,hint,ginteger,ainteger,hinteger,gfloat,afloat,hfloat
    ,gdouble,adouble,hdouble,grational,arational,hrational,gparens,aparens
    ,hparens,gbrackets,abrackets,hbrackets,gbraces,abraces,hbraces,gquotes
    ,aquotes,hquotes,gdoubleQuotes,adoubleQuotes,hdoubleQuotes,(!<>),(+<>),(*<>)
    ,(!<+>),(+<+>),(*<+>),ghcat,ghsep,(!$$),(+$$),(*$$),(!$+$),(+$+$),(*$+$)
    ,gvcat,gsep,gcat,gfsep,gfcat,gnest,anest,hnest,ghang,ahang,hhang,gpunctuate
    ,apunctuate,hpunctuate,gisEmpty,aisEmpty,hisEmpty,grender,arender,hrender
    ,Style(Style,bmode,blineLength,bribbonsPerLine),aStyle,gmode,glineLength
    ,gribbonsPerLine,hmode,hlineLength,hribbonsPerLine,amode,alineLength
    ,aribbonsPerLine,gstyle,grenderStyle,arenderStyle,hrenderStyle,gfullRender
    ,afullRender,hfullRender,Mode(PageMode,ZigZagMode,LeftMode,OneLineMode)
    ,aPageMode,aZigZagMode,aLeftMode,aOneLineMode,TextDetails(Chr,Str,PStr),aChr
    ,aStr,aPStr) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 

gisEmpty :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc Bool)

hisEmpty :: (T.R Doc) -> T.RefExp -> T.R Bool

gempty :: T.RefSrcPos -> T.RefExp -> T.R Doc

sempty :: T.R Doc

gsemi :: T.RefSrcPos -> T.RefExp -> T.R Doc

ssemi :: T.R Doc

gcomma :: T.RefSrcPos -> T.RefExp -> T.R Doc

scomma :: T.R Doc

gcolon :: T.RefSrcPos -> T.RefExp -> T.R Doc

scolon :: T.R Doc

gspace :: T.RefSrcPos -> T.RefExp -> T.R Doc

sspace :: T.R Doc

gequals :: T.RefSrcPos -> T.RefExp -> T.R Doc

sequals :: T.R Doc

glparen :: T.RefSrcPos -> T.RefExp -> T.R Doc

slparen :: T.R Doc

grparen :: T.RefSrcPos -> T.RefExp -> T.R Doc

srparen :: T.R Doc

glbrack :: T.RefSrcPos -> T.RefExp -> T.R Doc

slbrack :: T.R Doc

grbrack :: T.RefSrcPos -> T.RefExp -> T.R Doc

srbrack :: T.R Doc

glbrace :: T.RefSrcPos -> T.RefExp -> T.R Doc

slbrace :: T.R Doc

grbrace :: T.RefSrcPos -> T.RefExp -> T.R Doc

srbrace :: T.R Doc

gtext :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun String Doc)

htext :: (T.R String) -> T.RefExp -> T.R Doc

gptext :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun String Doc)

hptext :: (T.R String) -> T.RefExp -> T.R Doc

gchar :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Char Doc)

hchar :: (T.R Char) -> T.RefExp -> T.R Doc

gint :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Int Doc)

hint :: (T.R Int) -> T.RefExp -> T.R Doc

ginteger :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Integer Doc)

hinteger :: (T.R Integer) -> T.RefExp -> T.R Doc

gfloat :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Float Doc)

hfloat :: (T.R Float) -> T.RefExp -> T.R Doc

gdouble :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Double Doc)

hdouble :: (T.R Double) -> T.RefExp -> T.R Doc

grational :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Rational Doc)

hrational :: (T.R Rational) -> T.RefExp -> T.R Doc

gparens :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc Doc)

hparens :: (T.R Doc) -> T.RefExp -> T.R Doc

gbrackets :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc Doc)

hbrackets :: (T.R Doc) -> T.RefExp -> T.R Doc

gbraces :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc Doc)

hbraces :: (T.R Doc) -> T.RefExp -> T.R Doc

gquotes :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc Doc)

hquotes :: (T.R Doc) -> T.RefExp -> T.R Doc

gdoubleQuotes :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc Doc)

hdoubleQuotes :: (T.R Doc) -> T.RefExp -> T.R Doc

(!<>) :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc (T.Fun Doc Doc))

(*<>) :: (T.R Doc) -> (T.R Doc) -> T.RefExp -> T.R Doc

ghcat :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.List Doc) Doc)

shcat :: T.R (T.Fun (T.List Doc) Doc)

(!<+>) :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc (T.Fun Doc Doc))

(*<+>) :: (T.R Doc) -> (T.R Doc) -> T.RefExp -> T.R Doc

ghsep :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.List Doc) Doc)

shsep :: T.R (T.Fun (T.List Doc) Doc)

(!$$) :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc (T.Fun Doc Doc))

(*$$) :: (T.R Doc) -> (T.R Doc) -> T.RefExp -> T.R Doc

gvcat :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.List Doc) Doc)

svcat :: T.R (T.Fun (T.List Doc) Doc)

gcat :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.List Doc) Doc)

scat :: T.R (T.Fun (T.List Doc) Doc)

gsep :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.List Doc) Doc)

ssep :: T.R (T.Fun (T.List Doc) Doc)

gfcat :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.List Doc) Doc)

sfcat :: T.R (T.Fun (T.List Doc) Doc)

gfsep :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.List Doc) Doc)

sfsep :: T.R (T.Fun (T.List Doc) Doc)

gnest :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Int (T.Fun Doc Doc))

hnest :: (T.R Int) -> (T.R Doc) -> T.RefExp -> T.R Doc

ghang :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc (T.Fun Int (T.Fun Doc Doc)))

hhang :: (T.R Doc) -> (T.R Int) -> (T.R Doc) -> T.RefExp -> T.R Doc

gpunctuate ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc (T.Fun (T.List Doc) (T.List Doc)))

hpunctuate :: (T.R Doc) -> (T.R (T.List Doc)) -> T.RefExp -> T.R (T.List Doc)

instance Show (Doc)
  where
  
  gshowsPrec pshowsPrec p =
    T.ufun3 a285v3v285v44showsPrec pshowsPrec p hshowsPrec
    where
    
    hshowsPrec fprec fdoc fcont p = T.uwrapForward p (hshowDoc fdoc fcont p)
    
  

grender :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc String)

hrender :: (T.R Doc) -> T.RefExp -> T.R String

gfullRender ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun Mode
          (T.Fun Int
            (T.Fun Float
              (T.Fun (T.Fun TextDetails (T.Fun a a)) (T.Fun a (T.Fun Doc a))))))

hfullRender ::
  (T.R Mode) ->
    (T.R Int) ->
      (T.R Float) ->
        (T.R (T.Fun TextDetails (T.Fun a a))) ->
          (T.R a) -> (T.R Doc) -> T.RefExp -> T.R a

grenderStyle :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Style (T.Fun Doc String))

hrenderStyle :: (T.R Style) -> (T.R Doc) -> T.RefExp -> T.R String

data Style =
  Style {bmode :: T.R Mode,blineLength :: T.R Int,bribbonsPerLine :: T.R Float}

instance T.WrapVal (Style)
  where
  
  wrapVal pwrapVal
    (kwrapVal@(Style (T.R _ z1wrapVal) (T.R _ z2wrapVal) (T.R _ z3wrapVal))) p =
    T.R kwrapVal (T.mkValueApp3 p pwrapVal aStyle z1wrapVal z2wrapVal z3wrapVal)
  

gmode pmode p = T.ufun1 amode pmode p hmode

hmode (T.R z1mode _) p = T.projection T.mkNoSrcPos p (bmode z1mode)

glineLength plineLength p = T.ufun1 alineLength plineLength p hlineLength

hlineLength (T.R z1lineLength _) p =
  T.projection T.mkNoSrcPos p (blineLength z1lineLength)

gribbonsPerLine pribbonsPerLine p =
  T.ufun1 aribbonsPerLine pribbonsPerLine p hribbonsPerLine

hribbonsPerLine (T.R z1ribbonsPerLine _) p =
  T.projection T.mkNoSrcPos p (bribbonsPerLine z1ribbonsPerLine)

gstyle :: T.RefSrcPos -> T.RefExp -> T.R Style

sstyle :: T.R Style

gstyle pstyle p = T.uconstUse pstyle p sstyle

sstyle =
  T.uconstDef T.mkRoot astyle
    (\ p ->
      T.wrapVal T.mkNoSrcPos
        ((Style (Hat.PreludeBasic.gundefined T.mkNoSrcPos p)
            (Hat.PreludeBasic.gundefined T.mkNoSrcPos p)
            (Hat.PreludeBasic.gundefined T.mkNoSrcPos p))
          {blineLength
            = T.uap1 T.mkNoSrcPos p
              (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
              (T.conInteger T.mkNoSrcPos p 100)
          ,bribbonsPerLine
            = T.uap1 T.mkNoSrcPos p
              (Hat.PreludeBasic.gfromRational T.mkNoSrcPos p)
              (T.R
                ((T.conInteger T.mkNoSrcPos p 3)
                  Hat.PreludeBasic.:%
                  (T.conInteger T.mkNoSrcPos p 2))
                (T.mkAtomRational T.mkNoSrcPos p 1.5))
          ,bmode = T.con0 T.mkNoSrcPos p PageMode aPageMode}) p)

data Mode = PageMode  | ZigZagMode  | LeftMode  | OneLineMode 

instance T.WrapVal (Mode)
  where
  
  wrapVal pwrapVal (kwrapVal@PageMode) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aPageMode)
  wrapVal pwrapVal (kwrapVal@ZigZagMode) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aZigZagMode)
  wrapVal pwrapVal (kwrapVal@LeftMode) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aLeftMode)
  wrapVal pwrapVal (kwrapVal@OneLineMode) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aOneLineMode)
  

gsemi psemi p = T.uconstUse psemi p ssemi

ssemi =
  T.uconstDef T.mkRoot asemi
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p ';') p))

gcolon pcolon p = T.uconstUse pcolon p scolon

scolon =
  T.uconstDef T.mkRoot acolon
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p ':') p))

gcomma pcomma p = T.uconstUse pcomma p scomma

scomma =
  T.uconstDef T.mkRoot acomma
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p ',') p))

gspace pspace p = T.uconstUse pspace p sspace

sspace =
  T.uconstDef T.mkRoot aspace
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p ' ') p))

gequals pequals p = T.uconstUse pequals p sequals

sequals =
  T.uconstDef T.mkRoot aequals
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '=') p))

glparen plparen p = T.uconstUse plparen p slparen

slparen =
  T.uconstDef T.mkRoot alparen
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '(') p))

grparen prparen p = T.uconstUse prparen p srparen

srparen =
  T.uconstDef T.mkRoot arparen
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p ')') p))

glbrack plbrack p = T.uconstUse plbrack p slbrack

slbrack =
  T.uconstDef T.mkRoot albrack
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '[') p))

grbrack prbrack p = T.uconstUse prbrack p srbrack

srbrack =
  T.uconstDef T.mkRoot arbrack
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p ']') p))

glbrace plbrace p = T.uconstUse plbrace p slbrace

slbrace =
  T.uconstDef T.mkRoot albrace
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '{') p))

grbrace prbrace p = T.uconstUse prbrace p srbrace

srbrace =
  T.uconstDef T.mkRoot arbrace
    (\ p -> T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '}') p))

gint pint p = T.ufun1 aint pint p hint

hint fn p =
  T.uwrapForward p (htext (T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p) fn) p)

ginteger pinteger p = T.ufun1 ainteger pinteger p hinteger

hinteger fn p =
  T.uwrapForward p (htext (T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p) fn) p)

gfloat pfloat p = T.ufun1 afloat pfloat p hfloat

hfloat fn p =
  T.uwrapForward p (htext (T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p) fn) p)

gdouble pdouble p = T.ufun1 adouble pdouble p hdouble

hdouble fn p =
  T.uwrapForward p (htext (T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p) fn) p)

grational prational p = T.ufun1 arational prational p hrational

hrational fn p =
  T.uwrapForward p (htext (T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p) fn) p)

gquotes pquotes p = T.ufun1 aquotes pquotes p hquotes

hquotes fp p =
  T.uwrapForward p
    (((T.uwrapForward p
          (((T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '`') p)) *<> fp)
            p))
        *<>
        (T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '\'') p))) p)

gdoubleQuotes pdoubleQuotes p =
  T.ufun1 adoubleQuotes pdoubleQuotes p hdoubleQuotes

hdoubleQuotes fp p =
  T.uwrapForward p
    (((T.uwrapForward p
          (((T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '"') p)) *<> fp)
            p))
        *<>
        (T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '"') p))) p)

gparens pparens p = T.ufun1 aparens pparens p hparens

hparens fp p =
  T.uwrapForward p
    (((T.uwrapForward p
          (((T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '(') p)) *<> fp)
            p))
        *<>
        (T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p ')') p))) p)

gbrackets pbrackets p = T.ufun1 abrackets pbrackets p hbrackets

hbrackets fp p =
  T.uwrapForward p
    (((T.uwrapForward p
          (((T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '[') p)) *<> fp)
            p))
        *<>
        (T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p ']') p))) p)

gbraces pbraces p = T.ufun1 abraces pbraces p hbraces

hbraces fp p =
  T.uwrapForward p
    (((T.uwrapForward p
          (((T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '{') p)) *<> fp)
            p))
        *<>
        (T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '}') p))) p)

ghcat phcat p = T.uconstUse phcat p shcat

shcat =
  T.uconstDef T.mkRoot ahcat
    (\ p ->
      T.uap2 T.mkNoSrcPos p (gfoldr T.mkNoSrcPos p) (T.mkNoSrcPos !<> p)
        (gempty T.mkNoSrcPos p))

ghsep phsep p = T.uconstUse phsep p shsep

shsep =
  T.uconstDef T.mkRoot ahsep
    (\ p ->
      T.uap2 T.mkNoSrcPos p (gfoldr T.mkNoSrcPos p) (T.mkNoSrcPos !<+> p)
        (gempty T.mkNoSrcPos p))

gvcat pvcat p = T.uconstUse pvcat p svcat

svcat =
  T.uconstDef T.mkRoot avcat
    (\ p ->
      T.uap2 T.mkNoSrcPos p (gfoldr T.mkNoSrcPos p) (T.mkNoSrcPos !$$ p)
        (gempty T.mkNoSrcPos p))

ghang phang p = T.ufun3 ahang phang p hhang

hhang fd1 fn fd2 p =
  T.uap1 T.mkNoSrcPos p (gsep T.mkNoSrcPos p)
    (T.fromExpList T.mkNoSrcPos p [fd1,T.uwrapForward p (hnest fn fd2 p)])

gpunctuate ppunctuate p = T.ufun2 apunctuate ppunctuate p hpunctuate

hpunctuate fp (T.R T.List _) p = T.con0 T.mkNoSrcPos p T.List T.aList
hpunctuate fp (T.R (T.Cons fd fds) _) p =
  T.uwrapForward p (hgo fd fds p)
  where
  
  ggo pgo p = T.ufun2 a431v22v432v53go pgo p hgo
  
  ago = a431v22v432v53go
  
  hgo fd (T.R T.List _) p = T.fromExpList T.mkNoSrcPos p [fd]
  hgo fd (T.R (T.Cons fe fes) _) p =
    T.con2 T.mkNoSrcPos p T.Cons T.aCons (T.uwrapForward p ((fd *<> fp) p))
      (T.uwrapForward p (hgo fe fes p))
  hgo _ _ p = T.fatal p
  
hpunctuate _ _ p = T.fatal p

data Doc =
  Empty  | NilAbove (T.R Doc)
  | TextBeside (T.R TextDetails) !(T.R Int) (T.R Doc)
  | Nest !(T.R Int) (T.R Doc) | Union (T.R Doc) (T.R Doc) | NoDoc 
  | Beside (T.R Doc) (T.R Bool) (T.R Doc) | Above (T.R Doc) (T.R Bool) (T.R Doc)

instance T.WrapVal (Doc)
  where
  
  wrapVal pwrapVal (kwrapVal@Empty) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aEmpty)
  wrapVal pwrapVal (kwrapVal@(NilAbove (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aNilAbove z1wrapVal)
  wrapVal pwrapVal
    (kwrapVal@(TextBeside (T.R _ z1wrapVal) (T.R _ z2wrapVal)
        (T.R _ z3wrapVal))) p =
    T.R kwrapVal
      (T.mkValueApp3 p pwrapVal aTextBeside z1wrapVal z2wrapVal z3wrapVal)
  wrapVal pwrapVal (kwrapVal@(Nest (T.R _ z1wrapVal) (T.R _ z2wrapVal))) p =
    T.R kwrapVal (T.mkValueApp2 p pwrapVal aNest z1wrapVal z2wrapVal)
  wrapVal pwrapVal (kwrapVal@(Union (T.R _ z1wrapVal) (T.R _ z2wrapVal))) p =
    T.R kwrapVal (T.mkValueApp2 p pwrapVal aUnion z1wrapVal z2wrapVal)
  wrapVal pwrapVal (kwrapVal@NoDoc) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aNoDoc)
  wrapVal pwrapVal
    (kwrapVal@(Beside (T.R _ z1wrapVal) (T.R _ z2wrapVal) (T.R _ z3wrapVal)))
    p =
    T.R kwrapVal
      (T.mkValueApp3 p pwrapVal aBeside z1wrapVal z2wrapVal z3wrapVal)
  wrapVal pwrapVal
    (kwrapVal@(Above (T.R _ z1wrapVal) (T.R _ z2wrapVal) (T.R _ z3wrapVal))) p =
    T.R kwrapVal (T.mkValueApp3 p pwrapVal aAbove z1wrapVal z2wrapVal z3wrapVal)
  

type RDoc = Doc

greduceDoc :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc RDoc)

hreduceDoc :: (T.R Doc) -> T.RefExp -> T.R RDoc

greduceDoc preduceDoc p = T.ufun1 areduceDoc preduceDoc p hreduceDoc

hreduceDoc (T.R (Beside fp fg fq) _) p =
  T.uwrapForward p (hbeside fp fg (T.uwrapForward p (hreduceDoc fq p)) p)
hreduceDoc (T.R (Above fp fg fq) _) p =
  T.uwrapForward p (habove fp fg (T.uwrapForward p (hreduceDoc fq p)) p)
hreduceDoc fp p = T.projection T.mkNoSrcPos p fp

data TextDetails = Chr (T.R Char) | Str (T.R String) | PStr (T.R String)

instance T.WrapVal (TextDetails)
  where
  
  wrapVal pwrapVal (kwrapVal@(Chr (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aChr z1wrapVal)
  wrapVal pwrapVal (kwrapVal@(Str (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aStr z1wrapVal)
  wrapVal pwrapVal (kwrapVal@(PStr (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aPStr z1wrapVal)
  

gspace_text pspace_text p = T.uconstUse pspace_text p sspace_text

sspace_text =
  T.uconstDef T.mkRoot aspace_text
    (\ p -> T.con1 T.mkNoSrcPos p Chr aChr (T.conChar T.mkNoSrcPos p ' '))

gnl_text pnl_text p = T.uconstUse pnl_text p snl_text

snl_text =
  T.uconstDef T.mkRoot anl_text
    (\ p -> T.con1 T.mkNoSrcPos p Chr aChr (T.conChar T.mkNoSrcPos p '\n'))

gnilAbove_ pnilAbove_ p = T.ufun1 anilAbove_ pnilAbove_ p hnilAbove_

hnilAbove_ fp p = T.con1 T.mkNoSrcPos p NilAbove aNilAbove fp

gtextBeside_ ptextBeside_ p = T.ufun3 atextBeside_ ptextBeside_ p htextBeside_

htextBeside_ fs fsl fp p =
  T.con3 T.mkNoSrcPos p TextBeside aTextBeside fs fsl fp

gnest_ pnest_ p = T.ufun2 anest_ pnest_ p hnest_

hnest_ fk fp p = T.con2 T.mkNoSrcPos p Nest aNest fk fp

gunion_ punion_ p = T.ufun2 aunion_ punion_ p hunion_

hunion_ fp fq p = T.con2 T.mkNoSrcPos p Union aUnion fp fq

gempty pempty p = T.uconstUse pempty p sempty

sempty = T.uconstDef T.mkRoot aempty (\ p -> T.con0 T.mkNoSrcPos p Empty aEmpty)

gisEmpty pisEmpty p = T.ufun1 aisEmpty pisEmpty p hisEmpty

hisEmpty (T.R Empty _) p = T.con0 T.mkNoSrcPos p True aTrue
hisEmpty _ p = T.con0 T.mkNoSrcPos p False aFalse

gchar pchar p = T.ufun1 achar pchar p hchar

hchar fc p =
  T.uwrapForward p
    (htextBeside_ (T.con1 T.mkNoSrcPos p Chr aChr fc)
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 1)) (T.con0 T.mkNoSrcPos p Empty aEmpty) p)

gtext ptext p = T.ufun1 atext ptext p htext

htext fs p =
  T.uccase T.mkNoSrcPos p
    (let
      v523v11v523v65v1 fsl p =
        T.uwrapForward p
          (htextBeside_ (T.con1 T.mkNoSrcPos p Str aStr fs) fsl
            (T.con0 T.mkNoSrcPos p Empty aEmpty) p) in (v523v11v523v65v1))
    (T.uwrapForward p (hlength fs p))

gptext pptext p = T.ufun1 aptext pptext p hptext

hptext fs p =
  T.uccase T.mkNoSrcPos p
    (let
      v524v11v524v63v1 fsl p =
        T.uwrapForward p
          (htextBeside_ (T.con1 T.mkNoSrcPos p PStr aPStr fs) fsl
            (T.con0 T.mkNoSrcPos p Empty aEmpty) p) in (v524v11v524v63v1))
    (T.uwrapForward p (hlength fs p))

gnest pnest p = T.ufun2 anest pnest p hnest

hnest fk fp p =
  T.uwrapForward p (hmkNest fk (T.uwrapForward p (hreduceDoc fp p)) p)

gmkNest pmkNest p = T.ufun2 amkNest pmkNest p hmkNest

hmkNest fk (z2mkNest@_) p =
  T.ucguard (T.uwrapForward p (hseq fk (T.con0 T.mkNoSrcPos p False aFalse) p))
    (gundefined T.mkNoSrcPos p) (y1mkNest fk z2mkNest p)
hmkNest fk z2mkNest p = y1mkNest fk z2mkNest p

y1mkNest fk (T.R (Nest fk1 fp) _) p =
  T.uwrapForward p
    (hmkNest (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fk fk1) fp p)
y1mkNest fk (T.R NoDoc _) p = T.con0 T.mkNoSrcPos p NoDoc aNoDoc
y1mkNest fk (T.R Empty _) p = T.con0 T.mkNoSrcPos p Empty aEmpty
y1mkNest fv533v8v533v8n fp p =
  T.ucguard
    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!== p) fv533v8v533v8n
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 0))) (h fp p)
    (y2mkNest fv533v8v533v8n fp p)
  where
  
  h fp p = T.projection T.mkNoSrcPos p fp
  h _ p = y2mkNest fv533v8v533v8n fp p
  
y1mkNest fv533v8v533v8n fp p = y2mkNest fv533v8v533v8n fp p

y2mkNest fk fp p = T.uwrapForward p (hnest_ fk fp p)

gmkUnion pmkUnion p = T.ufun2 amkUnion pmkUnion p hmkUnion

hmkUnion (T.R Empty _) fq p = T.con0 T.mkNoSrcPos p Empty aEmpty
hmkUnion fp fq p = T.uwrapForward p (hunion_ fp fq p)

(!$$) (%$$) p = T.ufun2 (+$$) (%$$) p (*$$)

(*$$) fp fq p =
  T.con3 T.mkNoSrcPos p Above aAbove fp (T.con0 T.mkNoSrcPos p False aFalse) fq

(!$+$) (%$+$) p = T.ufun2 (+$+$) (%$+$) p (*$+$)

(*$+$) fp fq p =
  T.con3 T.mkNoSrcPos p Above aAbove fp (T.con0 T.mkNoSrcPos p True aTrue) fq

gabove ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc (T.Fun Bool (T.Fun RDoc RDoc)))

habove :: (T.R Doc) -> (T.R Bool) -> (T.R RDoc) -> T.RefExp -> T.R RDoc

gabove pabove p = T.ufun3 aabove pabove p habove

habove (T.R (Above fp fg1 fq1) _) fg2 fq2 p =
  T.uwrapForward p (habove fp fg1 (T.uwrapForward p (habove fq1 fg2 fq2 p)) p)
habove (fp@(T.R (Beside _ _ _) _)) fg fq p =
  T.uwrapForward p
    (haboveNest (T.uwrapForward p (hreduceDoc fp p)) fg
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 0)) (T.uwrapForward p (hreduceDoc fq p)) p)
habove fp fg fq p =
  T.uwrapForward p
    (haboveNest fp fg
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 0)) (T.uwrapForward p (hreduceDoc fq p)) p)

gaboveNest ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun RDoc (T.Fun Bool (T.Fun Int (T.Fun RDoc RDoc))))

haboveNest ::
  (T.R RDoc) -> (T.R Bool) -> (T.R Int) -> (T.R RDoc) -> T.RefExp -> T.R RDoc

gaboveNest paboveNest p = T.ufun4 aaboveNest paboveNest p haboveNest

haboveNest (z1aboveNest@_) (z2aboveNest@_) fk (z4aboveNest@_) p =
  T.ucguard (T.uwrapForward p (hseq fk (T.con0 T.mkNoSrcPos p False aFalse) p))
    (gundefined T.mkNoSrcPos p)
    (y1aboveNest z1aboveNest z2aboveNest fk z4aboveNest p)
haboveNest z1aboveNest z2aboveNest fk z4aboveNest p =
  y1aboveNest z1aboveNest z2aboveNest fk z4aboveNest p

y1aboveNest (T.R NoDoc _) fg fk fq p = T.con0 T.mkNoSrcPos p NoDoc aNoDoc
y1aboveNest (T.R (Union fp1 fp2) _) fg fk fq p =
  T.uwrapForward p
    (hunion_ (T.uwrapForward p (haboveNest fp1 fg fk fq p))
      (T.uwrapForward p (haboveNest fp2 fg fk fq p)) p)
y1aboveNest (T.R Empty _) fg fk fq p = T.uwrapForward p (hmkNest fk fq p)
y1aboveNest (T.R (Nest fk1 fp) _) fg fk fq p =
  T.uwrapForward p
    (hnest_ fk1
      (T.uwrapForward p
        (haboveNest fp fg (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fk fk1) fq
          p)) p)
y1aboveNest (T.R (NilAbove fp) _) fg fk fq p =
  T.uwrapForward p (hnilAbove_ (T.uwrapForward p (haboveNest fp fg fk fq p)) p)
y1aboveNest (T.R (TextBeside fs fsl fp) _) fg fk fq p =
  T.uwrapForward p
    (hseq (gk1 T.mkNoSrcPos p)
      (T.uwrapForward p (htextBeside_ fs fsl (grest T.mkNoSrcPos p) p)) p)
  where
  
  gk1 pk1 p = T.uconstUse pk1 p sk1
  
  sk1 =
    T.uconstDef p a566v39v566v51k1
      (\ p -> T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fk fsl)
  
  grest prest p = T.uconstUse prest p srest
  
  srest =
    T.uconstDef p a567v39v569v76rest
      (\ p ->
        T.uccase T.mkNoSrcPos p
          (let
            v567v46v569v76v1 (T.R Empty _) p =
              T.uwrapForward p (hnilAboveNest fg (gk1 T.mkNoSrcPos p) fq p)
            v567v46v569v76v1 fother p =
              T.uwrapForward p (haboveNest fp fg (gk1 T.mkNoSrcPos p) fq p) in
            (v567v46v569v76v1)) fp)
  
y1aboveNest _ _ _ _ p = T.fatal p

gnilAboveNest ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Bool (T.Fun Int (T.Fun RDoc RDoc)))

hnilAboveNest :: (T.R Bool) -> (T.R Int) -> (T.R RDoc) -> T.RefExp -> T.R RDoc

gnilAboveNest pnilAboveNest p =
  T.ufun3 anilAboveNest pnilAboveNest p hnilAboveNest

hnilAboveNest (z1nilAboveNest@_) fk (z3nilAboveNest@_) p =
  T.ucguard (T.uwrapForward p (hseq fk (T.con0 T.mkNoSrcPos p False aFalse) p))
    (gundefined T.mkNoSrcPos p)
    (y1nilAboveNest z1nilAboveNest fk z3nilAboveNest p)
hnilAboveNest z1nilAboveNest fk z3nilAboveNest p =
  y1nilAboveNest z1nilAboveNest fk z3nilAboveNest p

y1nilAboveNest fg fk (T.R Empty _) p = T.con0 T.mkNoSrcPos p Empty aEmpty
y1nilAboveNest fg fk (T.R (Nest fk1 fq) _) p =
  T.uwrapForward p
    (hnilAboveNest fg (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fk fk1) fq p)
y1nilAboveNest fg fk fq p =
  T.ucguard
    (T.uwrapForward p
      (((T.uwrapForward p (hnot fg p))
          *&&
          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !> p) fk
            (T.uap1 T.mkNoSrcPos p
              (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
              (T.conInteger T.mkNoSrcPos p 0)))) p))
    (T.uwrapForward p
      (htextBeside_
        (T.con1 T.mkNoSrcPos p Str aStr (T.uwrapForward p (hspaces fk p))) fk fq
        p))
    (T.ucguard (gotherwise T.mkNoSrcPos p)
      (T.uwrapForward p (hnilAbove_ (T.uwrapForward p (hmkNest fk fq p)) p))
      (T.fatal p))

(!<>) (%<>) p = T.ufun2 (+<>) (%<>) p (*<>)

(*<>) fp fq p =
  T.con3 T.mkNoSrcPos p Beside aBeside fp (T.con0 T.mkNoSrcPos p False aFalse)
    fq

(!<+>) (%<+>) p = T.ufun2 (+<+>) (%<+>) p (*<+>)

(*<+>) fp fq p =
  T.con3 T.mkNoSrcPos p Beside aBeside fp (T.con0 T.mkNoSrcPos p True aTrue) fq

gbeside ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc (T.Fun Bool (T.Fun RDoc RDoc)))

hbeside :: (T.R Doc) -> (T.R Bool) -> (T.R RDoc) -> T.RefExp -> T.R RDoc

gbeside pbeside p = T.ufun3 abeside pbeside p hbeside

hbeside (T.R NoDoc _) fg fq p = T.con0 T.mkNoSrcPos p NoDoc aNoDoc
hbeside (T.R (Union fp1 fp2) _) fg fq p =
  T.uwrapForward p
    (hunion_ (T.uwrapForward p (hbeside fp1 fg fq p))
      (T.uwrapForward p (hbeside fp2 fg fq p)) p)
hbeside (T.R Empty _) fg fq p = T.projection T.mkNoSrcPos p fq
hbeside (T.R (Nest fk fp) _) fg fq p =
  T.uwrapForward p (hnest_ fk (T.uwrapForward p (hbeside fp fg fq p)) p)
hbeside (fp@(T.R (Beside fp1 fg1 fq1) _)) fg2 fq2 p =
  T.ucguard (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !== p) fg1 fg2)
    (T.uwrapForward p
      (hbeside fp1 fg1 (T.uwrapForward p (hbeside fq1 fg2 fq2 p)) p))
    (T.ucguard (gotherwise T.mkNoSrcPos p)
      (T.uwrapForward p
        (hbeside (T.uwrapForward p (hreduceDoc fp p)) fg2 fq2 p)) (T.fatal p))
hbeside (fp@(T.R (Above _ _ _) _)) fg fq p =
  T.uwrapForward p (hbeside (T.uwrapForward p (hreduceDoc fp p)) fg fq p)
hbeside (T.R (NilAbove fp) _) fg fq p =
  T.uwrapForward p (hnilAbove_ (T.uwrapForward p (hbeside fp fg fq p)) p)
hbeside (T.R (TextBeside fs fsl fp) _) fg fq p =
  T.uwrapForward p (htextBeside_ fs fsl (grest T.mkNoSrcPos p) p)
  where
  
  grest prest p = T.uconstUse prest p srest
  
  srest =
    T.uconstDef p a607v35v609v64rest
      (\ p ->
        T.uccase T.mkNoSrcPos p
          (let
            v607v42v609v64v1 (T.R Empty _) p =
              T.uwrapForward p (hnilBeside fg fq p)
            v607v42v609v64v1 fother p = T.uwrapForward p (hbeside fp fg fq p) in
            (v607v42v609v64v1)) fp)
  
hbeside _ _ _ p = T.fatal p

gnilBeside :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Bool (T.Fun RDoc RDoc))

hnilBeside :: (T.R Bool) -> (T.R RDoc) -> T.RefExp -> T.R RDoc

gnilBeside pnilBeside p = T.ufun2 anilBeside pnilBeside p hnilBeside

hnilBeside fg (T.R Empty _) p = T.con0 T.mkNoSrcPos p Empty aEmpty
hnilBeside fg (T.R (Nest _ fp) _) p = T.uwrapForward p (hnilBeside fg fp p)
hnilBeside fg fp p =
  T.ucguard fg
    (T.uwrapForward p
      (htextBeside_ (gspace_text T.mkNoSrcPos p)
        (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
          (T.conInteger T.mkNoSrcPos p 1)) fp p))
    (T.ucguard (gotherwise T.mkNoSrcPos p) (T.projection T.mkNoSrcPos p fp)
      (T.fatal p))

gsep psep p = T.uconstUse psep p ssep

ssep =
  T.uconstDef T.mkRoot asep
    (\ p ->
      T.uap1 T.mkNoSrcPos p (gsepX T.mkNoSrcPos p)
        (T.con0 T.mkNoSrcPos p True aTrue))

gcat pcat p = T.uconstUse pcat p scat

scat =
  T.uconstDef T.mkRoot acat
    (\ p ->
      T.uap1 T.mkNoSrcPos p (gsepX T.mkNoSrcPos p)
        (T.con0 T.mkNoSrcPos p False aFalse))

gsepX psepX p = T.ufun2 asepX psepX p hsepX

hsepX fx (T.R T.List _) p = gempty T.mkNoSrcPos p
hsepX fx (T.R (T.Cons fp fps) _) p =
  T.uwrapForward p
    (hsep1 fx (T.uwrapForward p (hreduceDoc fp p))
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 0)) fps p)
hsepX _ _ p = T.fatal p

gsep1 ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun Bool (T.Fun RDoc (T.Fun Int (T.Fun (T.List Doc) RDoc))))

hsep1 ::
  (T.R Bool) ->
    (T.R RDoc) -> (T.R Int) -> (T.R (T.List Doc)) -> T.RefExp -> T.R RDoc

gsep1 psep1 p = T.ufun4 asep1 psep1 p hsep1

hsep1 fg (z2sep1@_) fk fys p =
  T.ucguard (T.uwrapForward p (hseq fk (T.con0 T.mkNoSrcPos p False aFalse) p))
    (gundefined T.mkNoSrcPos p) (y1sep1 fg z2sep1 fk fys p)
hsep1 fg z2sep1 fk fys p = y1sep1 fg z2sep1 fk fys p

y1sep1 fg (T.R NoDoc _) fk fys p = T.con0 T.mkNoSrcPos p NoDoc aNoDoc
y1sep1 fg (T.R (Union fp fq) _) fk fys p =
  T.uwrapForward p
    (hunion_ (T.uwrapForward p (hsep1 fg fp fk fys p))
      (T.uwrapForward p
        (haboveNest fq (T.con0 T.mkNoSrcPos p False aFalse) fk
          (T.uwrapForward p
            (hreduceDoc (T.uap1 T.mkNoSrcPos p (gvcat T.mkNoSrcPos p) fys) p))
          p)) p)
y1sep1 fg (T.R Empty _) fk fys p =
  T.uwrapForward p (hmkNest fk (T.uwrapForward p (hsepX fg fys p)) p)
y1sep1 fg (T.R (Nest fn fp) _) fk fys p =
  T.uwrapForward p
    (hnest_ fn
      (T.uwrapForward p
        (hsep1 fg fp (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fk fn) fys p))
      p)
y1sep1 fg (T.R (NilAbove fp) _) fk fys p =
  T.uwrapForward p
    (hnilAbove_
      (T.uwrapForward p
        (haboveNest fp (T.con0 T.mkNoSrcPos p False aFalse) fk
          (T.uwrapForward p
            (hreduceDoc (T.uap1 T.mkNoSrcPos p (gvcat T.mkNoSrcPos p) fys) p))
          p)) p)
y1sep1 fg (T.R (TextBeside fs fsl fp) _) fk fys p =
  T.uwrapForward p
    (htextBeside_ fs fsl
      (T.uwrapForward p
        (hsepNB fg fp (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fk fsl) fys p))
      p)
y1sep1 _ _ _ _ p = T.fatal p

gsepNB psepNB p = T.ufun4 asepNB psepNB p hsepNB

hsepNB fg (T.R (Nest _ fp) _) fk fys p =
  T.uwrapForward p (hsepNB fg fp fk fys p)
hsepNB fg (T.R Empty _) fk fys p =
  T.uwrapForward p
    (hmkUnion
      (T.uwrapForward p
        (honeLiner
          (T.uwrapForward p
            (hnilBeside fg
              (T.uwrapForward p (hreduceDoc (grest T.mkNoSrcPos p) p)) p)) p))
      (T.uwrapForward p
        (hnilAboveNest (T.con0 T.mkNoSrcPos p False aFalse) fk
          (T.uwrapForward p
            (hreduceDoc (T.uap1 T.mkNoSrcPos p (gvcat T.mkNoSrcPos p) fys) p))
          p)) p)
  where
  
  grest prest p = T.uconstUse prest p srest
  
  srest =
    T.uconstDef p a662v29v663v54rest
      (\ p ->
        T.ucguard fg (T.uap1 T.mkNoSrcPos p (ghsep T.mkNoSrcPos p) fys)
          (T.ucguard (gotherwise T.mkNoSrcPos p)
            (T.uap1 T.mkNoSrcPos p (ghcat T.mkNoSrcPos p) fys) (T.fatal p)))
  
hsepNB fg fp fk fys p = T.uwrapForward p (hsep1 fg fp fk fys p)

gfsep pfsep p = T.uconstUse pfsep p sfsep

sfsep =
  T.uconstDef T.mkRoot afsep
    (\ p ->
      T.uap1 T.mkNoSrcPos p (gfill T.mkNoSrcPos p)
        (T.con0 T.mkNoSrcPos p True aTrue))

gfcat pfcat p = T.uconstUse pfcat p sfcat

sfcat =
  T.uconstDef T.mkRoot afcat
    (\ p ->
      T.uap1 T.mkNoSrcPos p (gfill T.mkNoSrcPos p)
        (T.con0 T.mkNoSrcPos p False aFalse))

gfill pfill p = T.ufun2 afill pfill p hfill

hfill fg (T.R T.List _) p = gempty T.mkNoSrcPos p
hfill fg (T.R (T.Cons fp fps) _) p =
  T.uwrapForward p
    (hfill1 fg (T.uwrapForward p (hreduceDoc fp p))
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 0)) fps p)
hfill _ _ p = T.fatal p

gfill1 ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun Bool (T.Fun RDoc (T.Fun Int (T.Fun (T.List Doc) Doc))))

hfill1 ::
  (T.R Bool) ->
    (T.R RDoc) -> (T.R Int) -> (T.R (T.List Doc)) -> T.RefExp -> T.R Doc

gfill1 pfill1 p = T.ufun4 afill1 pfill1 p hfill1

hfill1 fg (z2fill1@_) fk fys p =
  T.ucguard (T.uwrapForward p (hseq fk (T.con0 T.mkNoSrcPos p False aFalse) p))
    (gundefined T.mkNoSrcPos p) (y1fill1 fg z2fill1 fk fys p)
hfill1 fg z2fill1 fk fys p = y1fill1 fg z2fill1 fk fys p

y1fill1 fg (T.R NoDoc _) fk fys p = T.con0 T.mkNoSrcPos p NoDoc aNoDoc
y1fill1 fg (T.R (Union fp fq) _) fk fys p =
  T.uwrapForward p
    (hunion_ (T.uwrapForward p (hfill1 fg fp fk fys p))
      (T.uwrapForward p
        (haboveNest fq (T.con0 T.mkNoSrcPos p False aFalse) fk
          (T.uwrapForward p (hfill fg fys p)) p)) p)
y1fill1 fg (T.R Empty _) fk fys p =
  T.uwrapForward p (hmkNest fk (T.uwrapForward p (hfill fg fys p)) p)
y1fill1 fg (T.R (Nest fn fp) _) fk fys p =
  T.uwrapForward p
    (hnest_ fn
      (T.uwrapForward p
        (hfill1 fg fp (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fk fn) fys p))
      p)
y1fill1 fg (T.R (NilAbove fp) _) fk fys p =
  T.uwrapForward p
    (hnilAbove_
      (T.uwrapForward p
        (haboveNest fp (T.con0 T.mkNoSrcPos p False aFalse) fk
          (T.uwrapForward p (hfill fg fys p)) p)) p)
y1fill1 fg (T.R (TextBeside fs fsl fp) _) fk fys p =
  T.uwrapForward p
    (htextBeside_ fs fsl
      (T.uwrapForward p
        (hfillNB fg fp (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fk fsl) fys
          p)) p)
y1fill1 _ _ _ _ p = T.fatal p

gfillNB pfillNB p = T.ufun4 afillNB pfillNB p hfillNB

hfillNB fg (z2fillNB@_) fk fys p =
  T.ucguard (T.uwrapForward p (hseq fk (T.con0 T.mkNoSrcPos p False aFalse) p))
    (gundefined T.mkNoSrcPos p) (y1fillNB fg z2fillNB fk fys p)
hfillNB fg z2fillNB fk fys p = y1fillNB fg z2fillNB fk fys p

y1fillNB fg (T.R (Nest _ fp) _) fk fys p =
  T.uwrapForward p (hfillNB fg fp fk fys p)
y1fillNB fg (T.R Empty _) fk (T.R T.List _) p =
  T.con0 T.mkNoSrcPos p Empty aEmpty
y1fillNB fg (T.R Empty _) fk (T.R (T.Cons fy fys) _) p =
  T.uwrapForward p
    (hmkUnion
      (T.uwrapForward p
        (hnilBeside fg
          (T.uwrapForward p
            (hfill1 fg
              (T.uwrapForward p
                (honeLiner (T.uwrapForward p (hreduceDoc fy p)) p))
              (gk1 T.mkNoSrcPos p) fys p)) p))
      (T.uwrapForward p
        (hnilAboveNest (T.con0 T.mkNoSrcPos p False aFalse) fk
          (T.uwrapForward p
            (hfill fg (T.con2 T.mkNoSrcPos p T.Cons T.aCons fy fys) p)) p)) p)
  where
  
  gk1 pk1 p = T.uconstUse pk1 p sk1
  
  sk1 =
    T.uconstDef p a705v30v706v47k1
      (\ p ->
        T.ucguard fg
          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fk
            (T.uap1 T.mkNoSrcPos p
              (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
              (T.conInteger T.mkNoSrcPos p 1)))
          (T.ucguard (gotherwise T.mkNoSrcPos p)
            (T.projection T.mkNoSrcPos p fk) (T.fatal p)))
  
y1fillNB fg fp fk fys p = T.uwrapForward p (hfill1 fg fp fk fys p)

gbest ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun Mode (T.Fun Int (T.Fun Int (T.Fun RDoc RDoc))))

hbest ::
  (T.R Mode) -> (T.R Int) -> (T.R Int) -> (T.R RDoc) -> T.RefExp -> T.R RDoc

gbest pbest p = T.ufun4 abest pbest p hbest

hbest (T.R OneLineMode _) fw fr fp p =
  T.uwrapForward p (hget fp p)
  where
  
  gget pget p = T.ufun1 a723v5v728v50get pget p hget
  
  aget = a723v5v728v50get
  
  hget (T.R Empty _) p = T.con0 T.mkNoSrcPos p Empty aEmpty
  hget (T.R NoDoc _) p = T.con0 T.mkNoSrcPos p NoDoc aNoDoc
  hget (T.R (NilAbove fp) _) p =
    T.uwrapForward p (hnilAbove_ (T.uwrapForward p (hget fp p)) p)
  hget (T.R (TextBeside fs fsl fp) _) p =
    T.uwrapForward p (htextBeside_ fs fsl (T.uwrapForward p (hget fp p)) p)
  hget (T.R (Nest fk fp) _) p = T.uwrapForward p (hget fp p)
  hget (T.R (Union fp fq) _) p =
    T.uwrapForward p
      (hfirst (T.uwrapForward p (hget fp p)) (T.uwrapForward p (hget fq p)) p)
  hget _ p = T.fatal p
  
hbest fmode fw fr fp p =
  T.uwrapForward p (hget fw fp p)
  where
  
  gget :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Int (T.Fun Doc Doc))
  
  hget :: (T.R Int) -> (T.R Doc) -> T.RefExp -> T.R Doc
  
  gget pget p = T.ufun2 a735v5v741v61get pget p hget
  
  aget = a735v5v741v61get
  
  hget fw (z2get@_) p =
    T.ucguard
      (T.uwrapForward p
        (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !== p) fw
              (T.uap1 T.mkNoSrcPos p
                (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                (T.conInteger T.mkNoSrcPos p 0)))
            *&&
            (T.con0 T.mkNoSrcPos p False aFalse)) p))
      (gundefined T.mkNoSrcPos p) (y1get fw z2get p)
  hget fw z2get p = y1get fw z2get p
  
  y1get fw (T.R Empty _) p = T.con0 T.mkNoSrcPos p Empty aEmpty
  y1get fw (T.R NoDoc _) p = T.con0 T.mkNoSrcPos p NoDoc aNoDoc
  y1get fw (T.R (NilAbove fp) _) p =
    T.uwrapForward p (hnilAbove_ (T.uwrapForward p (hget fw fp p)) p)
  y1get fw (T.R (TextBeside fs fsl fp) _) p =
    T.uwrapForward p
      (htextBeside_ fs fsl (T.uwrapForward p (hget1 fw fsl fp p)) p)
  y1get fw (T.R (Nest fk fp) _) p =
    T.uwrapForward p
      (hnest_ fk
        (T.uwrapForward p
          (hget (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fw fk) fp p)) p)
  y1get fw (T.R (Union fp fq) _) p =
    T.uwrapForward p
      (hnicest fw fr (T.uwrapForward p (hget fw fp p))
        (T.uwrapForward p (hget fw fq p)) p)
  y1get _ _ p = T.fatal p
  
  gget1 ::
    T.RefSrcPos -> T.RefExp -> T.R (T.Fun Int (T.Fun Int (T.Fun Doc Doc)))
  
  hget1 :: (T.R Int) -> (T.R Int) -> (T.R Doc) -> T.RefExp -> T.R Doc
  
  gget1 pget1 p = T.ufun3 a748v5v755v63get1 pget1 p hget1
  
  aget1 = a748v5v755v63get1
  
  hget1 fw (z2get1@_) (z3get1@_) p =
    T.ucguard
      (T.uwrapForward p
        (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !== p) fw
              (T.uap1 T.mkNoSrcPos p
                (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                (T.conInteger T.mkNoSrcPos p 0)))
            *&&
            (T.con0 T.mkNoSrcPos p False aFalse)) p))
      (gundefined T.mkNoSrcPos p) (y1get1 fw z2get1 z3get1 p)
  hget1 fw z2get1 z3get1 p = y1get1 fw z2get1 z3get1 p
  
  y1get1 fw fsl (T.R Empty _) p = T.con0 T.mkNoSrcPos p Empty aEmpty
  y1get1 fw fsl (T.R NoDoc _) p = T.con0 T.mkNoSrcPos p NoDoc aNoDoc
  y1get1 fw fsl (T.R (NilAbove fp) _) p =
    T.uwrapForward p
      (hnilAbove_
        (T.uwrapForward p
          (hget (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fw fsl) fp p)) p)
  y1get1 fw fsl (T.R (TextBeside ft ftl fp) _) p =
    T.uwrapForward p
      (htextBeside_ ft ftl
        (T.uwrapForward p
          (hget1 fw (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fsl ftl) fp p))
        p)
  y1get1 fw fsl (T.R (Nest fk fp) _) p = T.uwrapForward p (hget1 fw fsl fp p)
  y1get1 fw fsl (T.R (Union fp fq) _) p =
    T.uwrapForward p
      (hnicest1 fw fr fsl (T.uwrapForward p (hget1 fw fsl fp p))
        (T.uwrapForward p (hget1 fw fsl fq p)) p)
  y1get1 _ _ _ p = T.fatal p
  

gnicest pnicest p = T.ufun4 anicest pnicest p hnicest

hnicest fw fr fp fq p =
  T.uwrapForward p
    (hnicest1 fw fr
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 0)) fp fq p)

gnicest1 pnicest1 p = T.ufun5 anicest1 pnicest1 p hnicest1

hnicest1 fw fr fsl fp fq p =
  T.ucguard
    (T.uwrapForward p
      (hfits
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p)
          (T.uwrapForward p (hminn fw fr p)) fsl) fp p))
    (T.projection T.mkNoSrcPos p fp)
    (T.ucguard (gotherwise T.mkNoSrcPos p) (T.projection T.mkNoSrcPos p fq)
      (T.fatal p))

gfits :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Int (T.Fun Doc Bool))

hfits :: (T.R Int) -> (T.R Doc) -> T.RefExp -> T.R Bool

gfits pfits p = T.ufun2 afits pfits p hfits

hfits fn fp p =
  T.ucguard
    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !< p) fn
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 0))) (T.con0 T.mkNoSrcPos p False aFalse)
    (y1fits fn fp p)
hfits fn fp p = y1fits fn fp p

y1fits fn (T.R NoDoc _) p = T.con0 T.mkNoSrcPos p False aFalse
y1fits fn (T.R Empty _) p = T.con0 T.mkNoSrcPos p True aTrue
y1fits fn (T.R (NilAbove _) _) p = T.con0 T.mkNoSrcPos p True aTrue
y1fits fn (T.R (TextBeside _ fsl fp) _) p =
  T.uwrapForward p
    (hfits (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fn fsl) fp p)
y1fits _ _ p = T.fatal p

gminn pminn p = T.ufun2 aminn pminn p hminn

hminn fx fy p =
  T.ucguard (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !< p) fx fy)
    (T.projection T.mkNoSrcPos p fx)
    (T.ucguard (gotherwise T.mkNoSrcPos p) (T.projection T.mkNoSrcPos p fy)
      (T.fatal p))

gfirst pfirst p = T.ufun2 afirst pfirst p hfirst

hfirst fp fq p =
  T.ucguard (T.uwrapForward p (hnonEmptySet fp p))
    (T.projection T.mkNoSrcPos p fp)
    (T.ucguard (gotherwise T.mkNoSrcPos p) (T.projection T.mkNoSrcPos p fq)
      (T.fatal p))

gnonEmptySet pnonEmptySet p = T.ufun1 anonEmptySet pnonEmptySet p hnonEmptySet

hnonEmptySet (T.R NoDoc _) p = T.con0 T.mkNoSrcPos p False aFalse
hnonEmptySet (T.R (Union fp fq) _) p = T.con0 T.mkNoSrcPos p True aTrue
hnonEmptySet (T.R Empty _) p = T.con0 T.mkNoSrcPos p True aTrue
hnonEmptySet (T.R (NilAbove fp) _) p = T.con0 T.mkNoSrcPos p True aTrue
hnonEmptySet (T.R (TextBeside _ _ fp) _) p =
  T.uwrapForward p (hnonEmptySet fp p)
hnonEmptySet (T.R (Nest _ fp) _) p = T.uwrapForward p (hnonEmptySet fp p)
hnonEmptySet _ p = T.fatal p

goneLiner :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Doc Doc)

honeLiner :: (T.R Doc) -> T.RefExp -> T.R Doc

goneLiner poneLiner p = T.ufun1 aoneLiner poneLiner p honeLiner

honeLiner (T.R NoDoc _) p = T.con0 T.mkNoSrcPos p NoDoc aNoDoc
honeLiner (T.R Empty _) p = T.con0 T.mkNoSrcPos p Empty aEmpty
honeLiner (T.R (NilAbove fp) _) p = T.con0 T.mkNoSrcPos p NoDoc aNoDoc
honeLiner (T.R (TextBeside fs fsl fp) _) p =
  T.uwrapForward p (htextBeside_ fs fsl (T.uwrapForward p (honeLiner fp p)) p)
honeLiner (T.R (Nest fk fp) _) p =
  T.uwrapForward p (hnest_ fk (T.uwrapForward p (honeLiner fp p)) p)
honeLiner (T.R (Union fp fq) _) p = T.uwrapForward p (honeLiner fp p)
honeLiner _ p = T.fatal p

grenderStyle prenderStyle p = T.ufun2 arenderStyle prenderStyle p hrenderStyle

hrenderStyle fstyle fdoc p =
  T.uap6 T.mkNoSrcPos p (gfullRender T.mkNoSrcPos p)
    (T.uwrapForward p (hmode fstyle p))
    (T.uwrapForward p (hlineLength fstyle p))
    (T.uwrapForward p (hribbonsPerLine fstyle p)) (gstring_txt T.mkNoSrcPos p)
    (T.fromLitString T.mkNoSrcPos p "") fdoc

grender prender p = T.ufun1 arender prender p hrender

hrender fdoc p =
  T.uwrapForward p (hshowDoc fdoc (T.fromLitString T.mkNoSrcPos p "") p)

gshowDoc pshowDoc p = T.ufun2 ashowDoc pshowDoc p hshowDoc

hshowDoc fdoc frest p =
  T.uap6 T.mkNoSrcPos p (gfullRender T.mkNoSrcPos p)
    (T.con0 T.mkNoSrcPos p PageMode aPageMode)
    (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
      (T.conInteger T.mkNoSrcPos p 100))
    (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromRational T.mkNoSrcPos p)
      (T.R
        ((T.conInteger T.mkNoSrcPos p 3)
          Hat.PreludeBasic.:%
          (T.conInteger T.mkNoSrcPos p 2))
        (T.mkAtomRational T.mkNoSrcPos p 1.5))) (gstring_txt T.mkNoSrcPos p)
    frest fdoc

gstring_txt pstring_txt p = T.ufun2 astring_txt pstring_txt p hstring_txt

hstring_txt (T.R (Chr fc) _) fs p = T.con2 T.mkNoSrcPos p T.Cons T.aCons fc fs
hstring_txt (T.R (Str fs1) _) fs2 p = T.uwrapForward p ((fs1 *++ fs2) p)
hstring_txt (T.R (PStr fs1) _) fs2 p = T.uwrapForward p ((fs1 *++ fs2) p)
hstring_txt _ _ p = T.fatal p

gfullRender pfullRender p = T.ufun6 afullRender pfullRender p hfullRender

hfullRender (T.R OneLineMode _) _ _ ftxt fend fdoc p =
  T.uwrapForward p
    (heasy_display (gspace_text T.mkNoSrcPos p) ftxt fend
      (T.uwrapForward p (hreduceDoc fdoc p)) p)
hfullRender (T.R LeftMode _) _ _ ftxt fend fdoc p =
  T.uwrapForward p
    (heasy_display (gnl_text T.mkNoSrcPos p) ftxt fend
      (T.uwrapForward p (hreduceDoc fdoc p)) p)
hfullRender fmode fline_length fribbons_per_line ftxt fend fdoc p =
  T.uap6 T.mkNoSrcPos p (gdisplay T.mkNoSrcPos p) fmode fline_length
    (gribbon_length T.mkNoSrcPos p) ftxt fend (gbest_doc T.mkNoSrcPos p)
  where
  
  gbest_doc pbest_doc p = T.uconstUse pbest_doc p sbest_doc
  
  sbest_doc =
    T.uconstDef p a823v5v823v72best_doc
      (\ p ->
        T.uwrapForward p
          (hbest fmode (ghacked_line_length T.mkNoSrcPos p)
            (gribbon_length T.mkNoSrcPos p)
            (T.uwrapForward p (hreduceDoc fdoc p)) p))
  
  ghacked_line_length,gribbon_length :: T.RefSrcPos -> T.RefExp -> T.R Int
  
  shacked_line_length,sribbon_length :: T.R Int
  
  gribbon_length pribbon_length p = T.uconstUse pribbon_length p sribbon_length
  
  sribbon_length =
    T.uconstDef p a826v5v826v70ribbon_length
      (\ p ->
        T.uap1 T.mkNoSrcPos p (ground T.mkNoSrcPos p)
          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !/ p)
            (T.uap1 T.mkNoSrcPos p (gfromIntegral T.mkNoSrcPos p) fline_length)
            fribbons_per_line))
  
  ghacked_line_length phacked_line_length p =
    T.uconstUse phacked_line_length p shacked_line_length
  
  shacked_line_length =
    T.uconstDef p a827v5v827v84hacked_line_length
      (\ p ->
        T.uccase T.mkNoSrcPos p
          (let
            v827v26v827v84v1 (T.R ZigZagMode _) p = gmaxBound T.mkNoSrcPos p
            v827v26v827v84v1 fother p = T.projection T.mkNoSrcPos p fline_length
            in (v827v26v827v84v1)) fmode)
  

gdisplay pdisplay p = T.ufun6 adisplay pdisplay p hdisplay

hdisplay fmode fpage_width fribbon_width ftxt fend fdoc p =
  T.uccase T.mkNoSrcPos p
    (let
      v830v5v864v13v1 fgap_width p =
        T.uccase T.mkNoSrcPos p
          (let
            v831v5v864v13v1 fshift p =
              let
                glay play p = T.ufun2 a833v9v853v42lay play p hlay
                alay = a833v9v853v42lay
                hlay fk (z2lay@_) p =
                  T.ucguard
                    (T.uwrapForward p
                      (hseq fk (T.con0 T.mkNoSrcPos p False aFalse) p))
                    (gundefined T.mkNoSrcPos p) (y1lay fk z2lay p)
                hlay fk z2lay p = y1lay fk z2lay p
                y1lay fk (T.R (Nest fk1 fp) _) p =
                  T.uwrapForward p
                    (hlay (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fk fk1) fp
                      p)
                y1lay fk (T.R Empty _) p = T.projection T.mkNoSrcPos p fend
                y1lay fk (T.R (NilAbove fp) _) p =
                  T.uap2 T.mkNoSrcPos p ftxt (gnl_text T.mkNoSrcPos p)
                    (T.uwrapForward p (hlay fk fp p))
                y1lay fk (T.R (TextBeside fs fsl fp) _) p =
                  T.uccase T.mkNoSrcPos p
                    (let
                      v840v15v853v42v1 (v840v15v853v42v2@(T.R ZigZagMode _)) p =
                        T.ucguard
                          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>= p) fk
                            fgap_width)
                          (T.uap2 T.mkNoSrcPos p ftxt (gnl_text T.mkNoSrcPos p)
                            (T.uap2 T.mkNoSrcPos p ftxt
                              (T.con1 T.mkNoSrcPos p Str aStr
                                (T.uwrapForward p
                                  (hmulti_ch fshift
                                    (T.conChar T.mkNoSrcPos p '/') p)))
                              (T.uap2 T.mkNoSrcPos p ftxt
                                (gnl_text T.mkNoSrcPos p)
                                (T.uwrapForward p
                                  (hlay1
                                    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p)
                                      fk fshift) fs fsl fp p)))))
                          (T.ucguard
                            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !< p) fk
                              (T.uap1 T.mkNoSrcPos p
                                (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                                (T.conInteger T.mkNoSrcPos p 0)))
                            (T.uap2 T.mkNoSrcPos p ftxt
                              (gnl_text T.mkNoSrcPos p)
                              (T.uap2 T.mkNoSrcPos p ftxt
                                (T.con1 T.mkNoSrcPos p Str aStr
                                  (T.uwrapForward p
                                    (hmulti_ch fshift
                                      (T.conChar T.mkNoSrcPos p '\\') p)))
                                (T.uap2 T.mkNoSrcPos p ftxt
                                  (gnl_text T.mkNoSrcPos p)
                                  (T.uwrapForward p
                                    (hlay1
                                      (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p)
                                        fk fshift) fs fsl fp p)))))
                            (v840v15v853v42v3 v840v15v853v42v2 p))
                      v840v15v853v42v1 v840v15v853v42v2 p =
                        v840v15v853v42v3 v840v15v853v42v2 p
                      v840v15v853v42v3 fother p =
                        T.uwrapForward p (hlay1 fk fs fsl fp p) in
                      (v840v15v853v42v1)) fmode
                y1lay _ _ p = T.fatal p
                glay1 play1 p = T.ufun4 a855v9v856v69lay1 play1 p hlay1
                alay1 = a855v9v856v69lay1
                hlay1 fk (z2lay1@_) fsl (z4lay1@_) p =
                  T.ucguard
                    (T.uwrapForward p
                      (hseq (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fk fsl)
                        (T.con0 T.mkNoSrcPos p False aFalse) p))
                    (gundefined T.mkNoSrcPos p) (y1lay1 fk z2lay1 fsl z4lay1 p)
                hlay1 fk z2lay1 fsl z4lay1 p = y1lay1 fk z2lay1 fsl z4lay1 p
                y1lay1 fk fs fsl fp p =
                  T.uap2 T.mkNoSrcPos p ftxt
                    (T.con1 T.mkNoSrcPos p Str aStr
                      (T.uwrapForward p (hindent fk p)))
                    (T.uap2 T.mkNoSrcPos p ftxt fs
                      (T.uwrapForward p
                        (hlay2
                          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fk fsl) fp
                          p)))
                glay2 play2 p = T.ufun2 a858v9v862v40lay2 play2 p hlay2
                alay2 = a858v9v862v40lay2
                hlay2 fk (z2lay2@_) p =
                  T.ucguard
                    (T.uwrapForward p
                      (hseq fk (T.con0 T.mkNoSrcPos p False aFalse) p))
                    (gundefined T.mkNoSrcPos p) (y1lay2 fk z2lay2 p)
                hlay2 fk z2lay2 p = y1lay2 fk z2lay2 p
                y1lay2 fk (T.R (NilAbove fp) _) p =
                  T.uap2 T.mkNoSrcPos p ftxt (gnl_text T.mkNoSrcPos p)
                    (T.uwrapForward p (hlay fk fp p))
                y1lay2 fk (T.R (TextBeside fs fsl fp) _) p =
                  T.uap2 T.mkNoSrcPos p ftxt fs
                    (T.uwrapForward p
                      (hlay2 (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fk fsl)
                        fp p))
                y1lay2 fk (T.R (Nest _ fp) _) p =
                  T.uwrapForward p (hlay2 fk fp p)
                y1lay2 fk (T.R Empty _) p = T.projection T.mkNoSrcPos p fend
                y1lay2 _ _ p = T.fatal p in
                (T.uwrapForward p
                  (hlay
                    (T.uap1 T.mkNoSrcPos p
                      (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                      (T.conInteger T.mkNoSrcPos p 0)) fdoc p)) in
            (v831v5v864v13v1))
          (T.uap2 T.mkNoSrcPos p (gquot T.mkNoSrcPos p) fgap_width
            (T.uap1 T.mkNoSrcPos p
              (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
              (T.conInteger T.mkNoSrcPos p 2))) in (v830v5v864v13v1))
    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fpage_width fribbon_width)

gcant_fail pcant_fail p = T.uconstUse pcant_fail p scant_fail

scant_fail =
  T.uconstDef T.mkRoot acant_fail
    (\ p ->
      T.uwrapForward p
        (herror (T.fromLitString T.mkNoSrcPos p "easy_display: NoDoc") p))

geasy_display peasy_display p =
  T.ufun4 aeasy_display peasy_display p heasy_display

heasy_display fnl_text ftxt fend fdoc p =
  T.uwrapForward p (hlay fdoc (gcant_fail T.mkNoSrcPos p) p)
  where
  
  glay play p = T.ufun2 a871v5v876v57lay play p hlay
  
  alay = a871v5v876v57lay
  
  hlay (T.R NoDoc _) fno_doc p = T.projection T.mkNoSrcPos p fno_doc
  hlay (T.R (Union fp fq) _) fno_doc p =
    T.uwrapForward p (hlay fq (gcant_fail T.mkNoSrcPos p) p)
  hlay (T.R (Nest fk fp) _) fno_doc p = T.uwrapForward p (hlay fp fno_doc p)
  hlay (T.R Empty _) fno_doc p = T.projection T.mkNoSrcPos p fend
  hlay (T.R (NilAbove fp) _) fno_doc p =
    T.uap2 T.mkNoSrcPos p ftxt fnl_text
      (T.uwrapForward p (hlay fp (gcant_fail T.mkNoSrcPos p) p))
  hlay (T.R (TextBeside fs fsl fp) _) fno_doc p =
    T.uap2 T.mkNoSrcPos p ftxt fs (T.uwrapForward p (hlay fp fno_doc p))
  hlay _ _ p = T.fatal p
  

gindent pindent p = T.ufun1 aindent pindent p hindent

hindent fn p =
  T.ucguard
    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>= p) fn
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 8)))
    (T.con2 T.mkNoSrcPos p T.Cons T.aCons (T.conChar T.mkNoSrcPos p '\t')
      (T.uwrapForward p
        (hindent
          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fn
            (T.uap1 T.mkNoSrcPos p
              (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
              (T.conInteger T.mkNoSrcPos p 8))) p)))
    (T.ucguard (gotherwise T.mkNoSrcPos p) (T.uwrapForward p (hspaces fn p))
      (T.fatal p))

gmulti_ch pmulti_ch p = T.ufun2 amulti_ch pmulti_ch p hmulti_ch

hmulti_ch fv881v10v881v10n fch p =
  T.ucguard
    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!== p) fv881v10v881v10n
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 0))) (h fch p)
    (y1multi_ch fv881v10v881v10n fch p)
  where
  
  h fch p = T.fromLitString T.mkNoSrcPos p ""
  h _ p = y1multi_ch fv881v10v881v10n fch p
  
hmulti_ch fv881v10v881v10n fch p = y1multi_ch fv881v10v881v10n fch p

y1multi_ch fn fch p =
  T.con2 T.mkNoSrcPos p T.Cons T.aCons fch
    (T.uwrapForward p
      (hmulti_ch
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fn
          (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
            (T.conInteger T.mkNoSrcPos p 1))) fch p))

gspaces pspaces p = T.ufun1 aspaces pspaces p hspaces

hspaces fv884v8v884v8n p =
  T.ucguard
    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!== p) fv884v8v884v8n
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 0))) (h p) (y1spaces fv884v8v884v8n p)
  where
  
  h p = T.fromLitString T.mkNoSrcPos p ""
  h p = y1spaces fv884v8v884v8n p
  
hspaces fv884v8v884v8n p = y1spaces fv884v8v884v8n p

y1spaces fn p =
  T.con2 T.mkNoSrcPos p T.Cons T.aCons (T.conChar T.mkNoSrcPos p ' ')
    (T.uwrapForward p
      (hspaces
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fn
          (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
            (T.conInteger T.mkNoSrcPos p 1))) p))

tText_PrettyPrint_HughesPJ =
  T.mkModule "Text.PrettyPrint.HughesPJ" "Text/PrettyPrint/HughesPJ.hs"
    Prelude.False

aStyle =
  T.mkConstructorWFields tText_PrettyPrint_HughesPJ 3040004 3040008 3 3 "Style"
    (amode : (alineLength : (aribbonsPerLine : [])))

aPageMode =
  T.mkConstructor tText_PrettyPrint_HughesPJ 3140013 3140020 3 0 "PageMode"

aZigZagMode =
  T.mkConstructor tText_PrettyPrint_HughesPJ 3150013 3150022 3 0 "ZigZagMode"

aLeftMode =
  T.mkConstructor tText_PrettyPrint_HughesPJ 3160013 3160020 3 0 "LeftMode"

aOneLineMode =
  T.mkConstructor tText_PrettyPrint_HughesPJ 3170013 3170023 3 0 "OneLineMode"

aEmpty = T.mkConstructor tText_PrettyPrint_HughesPJ 4420004 4420008 3 0 "Empty"

aNilAbove =
  T.mkConstructor tText_PrettyPrint_HughesPJ 4430004 4430011 3 1 "NilAbove"

aTextBeside =
  T.mkConstructor tText_PrettyPrint_HughesPJ 4440004 4440013 3 3 "TextBeside"

aNest = T.mkConstructor tText_PrettyPrint_HughesPJ 4450004 4450007 3 2 "Nest"

aUnion = T.mkConstructor tText_PrettyPrint_HughesPJ 4460004 4460008 3 2 "Union"

aNoDoc = T.mkConstructor tText_PrettyPrint_HughesPJ 4470004 4470008 3 0 "NoDoc"

aBeside =
  T.mkConstructor tText_PrettyPrint_HughesPJ 4480004 4480009 3 3 "Beside"

aAbove = T.mkConstructor tText_PrettyPrint_HughesPJ 4490004 4490008 3 3 "Above"

aChr = T.mkConstructor tText_PrettyPrint_HughesPJ 4600020 4600022 3 1 "Chr"

aStr = T.mkConstructor tText_PrettyPrint_HughesPJ 4610020 4610022 3 1 "Str"

aPStr = T.mkConstructor tText_PrettyPrint_HughesPJ 4620020 4620023 3 1 "PStr"

a285v3v285v44showsPrec =
  T.mkVariable tText_PrettyPrint_HughesPJ 2850003 2850044 3 3 "showsPrec"
    Prelude.False

amode =
  T.mkVariable tText_PrettyPrint_HughesPJ 3040012 3040015 3 1 "mode"
    Prelude.False

alineLength =
  T.mkVariable tText_PrettyPrint_HughesPJ 3050012 3050021 3 1 "lineLength"
    Prelude.False

aribbonsPerLine =
  T.mkVariable tText_PrettyPrint_HughesPJ 3060012 3060025 3 1 "ribbonsPerLine"
    Prelude.False

astyle =
  T.mkVariable tText_PrettyPrint_HughesPJ 3110001 3110059 3 0 "style"
    Prelude.False

asemi =
  T.mkVariable tText_PrettyPrint_HughesPJ 3950001 3950016 3 0 "semi"
    Prelude.False

acolon =
  T.mkVariable tText_PrettyPrint_HughesPJ 3960001 3960016 3 0 "colon"
    Prelude.False

acomma =
  T.mkVariable tText_PrettyPrint_HughesPJ 3970001 3970016 3 0 "comma"
    Prelude.False

aspace =
  T.mkVariable tText_PrettyPrint_HughesPJ 3980001 3980016 3 0 "space"
    Prelude.False

aequals =
  T.mkVariable tText_PrettyPrint_HughesPJ 3990001 3990017 3 0 "equals"
    Prelude.False

alparen =
  T.mkVariable tText_PrettyPrint_HughesPJ 4000001 4000017 3 0 "lparen"
    Prelude.False

arparen =
  T.mkVariable tText_PrettyPrint_HughesPJ 4010001 4010017 3 0 "rparen"
    Prelude.False

albrack =
  T.mkVariable tText_PrettyPrint_HughesPJ 4020001 4020017 3 0 "lbrack"
    Prelude.False

arbrack =
  T.mkVariable tText_PrettyPrint_HughesPJ 4030001 4030017 3 0 "rbrack"
    Prelude.False

albrace =
  T.mkVariable tText_PrettyPrint_HughesPJ 4040001 4040017 3 0 "lbrace"
    Prelude.False

arbrace =
  T.mkVariable tText_PrettyPrint_HughesPJ 4050001 4050017 3 0 "rbrace"
    Prelude.False

aint =
  T.mkVariable tText_PrettyPrint_HughesPJ 4070001 4070025 3 1 "int"
    Prelude.False

ainteger =
  T.mkVariable tText_PrettyPrint_HughesPJ 4080001 4080025 3 1 "integer"
    Prelude.False

afloat =
  T.mkVariable tText_PrettyPrint_HughesPJ 4090001 4090025 3 1 "float"
    Prelude.False

adouble =
  T.mkVariable tText_PrettyPrint_HughesPJ 4100001 4100025 3 1 "double"
    Prelude.False

arational =
  T.mkVariable tText_PrettyPrint_HughesPJ 4110001 4110025 3 1 "rational"
    Prelude.False

aquotes =
  T.mkVariable tText_PrettyPrint_HughesPJ 4150001 4150044 3 1 "quotes"
    Prelude.False

adoubleQuotes =
  T.mkVariable tText_PrettyPrint_HughesPJ 4160001 4160043 3 1 "doubleQuotes"
    Prelude.False

aparens =
  T.mkVariable tText_PrettyPrint_HughesPJ 4170001 4170043 3 1 "parens"
    Prelude.False

abrackets =
  T.mkVariable tText_PrettyPrint_HughesPJ 4180001 4180043 3 1 "brackets"
    Prelude.False

abraces =
  T.mkVariable tText_PrettyPrint_HughesPJ 4190001 4190043 3 1 "braces"
    Prelude.False

ahcat =
  T.mkVariable tText_PrettyPrint_HughesPJ 4220001 4220024 3 0 "hcat"
    Prelude.False

ahsep =
  T.mkVariable tText_PrettyPrint_HughesPJ 4230001 4230024 3 0 "hsep"
    Prelude.False

avcat =
  T.mkVariable tText_PrettyPrint_HughesPJ 4240001 4240024 3 0 "vcat"
    Prelude.False

ahang =
  T.mkVariable tText_PrettyPrint_HughesPJ 4260001 4260034 3 3 "hang"
    Prelude.False

apunctuate =
  T.mkVariable tText_PrettyPrint_HughesPJ 4280001 4320053 3 2 "punctuate"
    Prelude.False

areduceDoc =
  T.mkVariable tText_PrettyPrint_HughesPJ 4550001 4570028 3 1 "reduceDoc"
    Prelude.False

aspace_text =
  T.mkVariable tText_PrettyPrint_HughesPJ 4630001 4630020 3 0 "space_text"
    Prelude.False

anl_text =
  T.mkVariable tText_PrettyPrint_HughesPJ 4640001 4640021 3 0 "nl_text"
    Prelude.False

anilAbove_ =
  T.mkVariable tText_PrettyPrint_HughesPJ 4950001 4950024 3 1 "nilAbove_"
    Prelude.False

atextBeside_ =
  T.mkVariable tText_PrettyPrint_HughesPJ 4980001 4980038 3 3 "textBeside_"
    Prelude.False

anest_ =
  T.mkVariable tText_PrettyPrint_HughesPJ 5010001 5010020 3 2 "nest_"
    Prelude.False

aunion_ =
  T.mkVariable tText_PrettyPrint_HughesPJ 5040001 5040022 3 2 "union_"
    Prelude.False

aempty =
  T.mkVariable tText_PrettyPrint_HughesPJ 5170001 5170013 3 0 "empty"
    Prelude.False

aisEmpty =
  T.mkVariable tText_PrettyPrint_HughesPJ 5190001 5200021 3 1 "isEmpty"
    Prelude.False

achar =
  T.mkVariable tText_PrettyPrint_HughesPJ 5220001 5220037 3 1 "char"
    Prelude.False

atext =
  T.mkVariable tText_PrettyPrint_HughesPJ 5230001 5230065 3 1 "text"
    Prelude.False

aptext =
  T.mkVariable tText_PrettyPrint_HughesPJ 5240001 5240063 3 1 "ptext"
    Prelude.False

anest =
  T.mkVariable tText_PrettyPrint_HughesPJ 5260001 5260033 3 2 "nest"
    Prelude.False

amkNest =
  T.mkVariable tText_PrettyPrint_HughesPJ 5290001 5340038 3 2 "mkNest"
    Prelude.False

amkUnion =
  T.mkVariable tText_PrettyPrint_HughesPJ 5370001 5380030 3 2 "mkUnion"
    Prelude.False

(+$$) =
  T.mkVariable tText_PrettyPrint_HughesPJ 5430003 5430004 22 2 "$$"
    Prelude.False

(+$+$) =
  T.mkVariable tText_PrettyPrint_HughesPJ 5440003 5440005 22 2 "$+$"
    Prelude.False

aabove =
  T.mkVariable tText_PrettyPrint_HughesPJ 5470001 5490071 3 3 "above"
    Prelude.False

aaboveNest =
  T.mkVariable tText_PrettyPrint_HughesPJ 5540001 5690076 3 4 "aboveNest"
    Prelude.False

anilAboveNest =
  T.mkVariable tText_PrettyPrint_HughesPJ 5760001 5830052 3 3 "nilAboveNest"
    Prelude.False

(+<>) =
  T.mkVariable tText_PrettyPrint_HughesPJ 5880003 5880004 26 2 "<>"
    Prelude.False

(+<+>) =
  T.mkVariable tText_PrettyPrint_HughesPJ 5890003 5890005 26 2 "<+>"
    Prelude.False

abeside =
  T.mkVariable tText_PrettyPrint_HughesPJ 5940001 6090064 3 3 "beside"
    Prelude.False

anilBeside =
  T.mkVariable tText_PrettyPrint_HughesPJ 6160001 6190038 3 2 "nilBeside"
    Prelude.False

asep =
  T.mkVariable tText_PrettyPrint_HughesPJ 6280001 6280015 3 0 "sep"
    Prelude.False

acat =
  T.mkVariable tText_PrettyPrint_HughesPJ 6290001 6290016 3 0 "cat"
    Prelude.False

asepX =
  T.mkVariable tText_PrettyPrint_HughesPJ 6310001 6320041 3 2 "sepX"
    Prelude.False

asep1 =
  T.mkVariable tText_PrettyPrint_HughesPJ 6400001 6500073 3 4 "sep1"
    Prelude.False

asepNB =
  T.mkVariable tText_PrettyPrint_HughesPJ 6560001 6650041 3 4 "sepNB"
    Prelude.False

afsep =
  T.mkVariable tText_PrettyPrint_HughesPJ 6700001 6700016 3 0 "fsep"
    Prelude.False

afcat =
  T.mkVariable tText_PrettyPrint_HughesPJ 6710001 6710017 3 0 "fcat"
    Prelude.False

afill =
  T.mkVariable tText_PrettyPrint_HughesPJ 6810001 6820042 3 2 "fill"
    Prelude.False

afill1 =
  T.mkVariable tText_PrettyPrint_HughesPJ 6860001 6960075 3 4 "fill1"
    Prelude.False

afillNB =
  T.mkVariable tText_PrettyPrint_HughesPJ 6980001 7080043 3 4 "fillNB"
    Prelude.False

abest =
  T.mkVariable tText_PrettyPrint_HughesPJ 7200001 7550063 3 4 "best"
    Prelude.False

anicest =
  T.mkVariable tText_PrettyPrint_HughesPJ 7570001 7570034 3 4 "nicest"
    Prelude.False

anicest1 =
  T.mkVariable tText_PrettyPrint_HughesPJ 7580001 7590052 3 5 "nicest1"
    Prelude.False

afits =
  T.mkVariable tText_PrettyPrint_HughesPJ 7650001 7690044 3 2 "fits"
    Prelude.False

aminn =
  T.mkVariable tText_PrettyPrint_HughesPJ 7710001 7720024 3 2 "minn"
    Prelude.False

afirst =
  T.mkVariable tText_PrettyPrint_HughesPJ 7770001 7780029 3 2 "first"
    Prelude.False

anonEmptySet =
  T.mkVariable tText_PrettyPrint_HughesPJ 7800001 7850046 3 1 "nonEmptySet"
    Prelude.False

aoneLiner =
  T.mkVariable tText_PrettyPrint_HughesPJ 7900001 7950041 3 1 "oneLiner"
    Prelude.False

arenderStyle =
  T.mkVariable tText_PrettyPrint_HughesPJ 8010001 8070018 3 2 "renderStyle"
    Prelude.False

arender =
  T.mkVariable tText_PrettyPrint_HughesPJ 8090001 8090033 3 1 "render"
    Prelude.False

ashowDoc =
  T.mkVariable tText_PrettyPrint_HughesPJ 8100001 8100065 3 2 "showDoc"
    Prelude.False

astring_txt =
  T.mkVariable tText_PrettyPrint_HughesPJ 8120001 8140034 3 2 "string_txt"
    Prelude.False

afullRender =
  T.mkVariable tText_PrettyPrint_HughesPJ 8170001 8270084 3 6 "fullRender"
    Prelude.False

adisplay =
  T.mkVariable tText_PrettyPrint_HughesPJ 8290001 8640013 3 6 "display"
    Prelude.False

acant_fail =
  T.mkVariable tText_PrettyPrint_HughesPJ 8670001 8670039 3 0 "cant_fail"
    Prelude.False

aeasy_display =
  T.mkVariable tText_PrettyPrint_HughesPJ 8680001 8760057 3 4 "easy_display"
    Prelude.False

aindent =
  T.mkVariable tText_PrettyPrint_HughesPJ 8780001 8790036 3 1 "indent"
    Prelude.False

amulti_ch =
  T.mkVariable tText_PrettyPrint_HughesPJ 8810001 8820046 3 2 "multi_ch"
    Prelude.False

aspaces =
  T.mkVariable tText_PrettyPrint_HughesPJ 8840001 8850036 3 1 "spaces"
    Prelude.False

a431v22v432v53go =
  T.mkVariable tText_PrettyPrint_HughesPJ 4310022 4320053 3 2 "go" Prelude.True

a566v39v566v51k1 =
  T.mkVariable tText_PrettyPrint_HughesPJ 5660039 5660051 3 0 "k1" Prelude.True

a567v39v569v76rest =
  T.mkVariable tText_PrettyPrint_HughesPJ 5670039 5690076 3 0 "rest"
    Prelude.True

a607v35v609v64rest =
  T.mkVariable tText_PrettyPrint_HughesPJ 6070035 6090064 3 0 "rest"
    Prelude.True

a662v29v663v54rest =
  T.mkVariable tText_PrettyPrint_HughesPJ 6620029 6630054 3 0 "rest"
    Prelude.True

a705v30v706v47k1 =
  T.mkVariable tText_PrettyPrint_HughesPJ 7050030 7060047 3 0 "k1" Prelude.True

a723v5v728v50get =
  T.mkVariable tText_PrettyPrint_HughesPJ 7230005 7280050 3 1 "get" Prelude.True

a735v5v741v61get =
  T.mkVariable tText_PrettyPrint_HughesPJ 7350005 7410061 3 2 "get" Prelude.True

a748v5v755v63get1 =
  T.mkVariable tText_PrettyPrint_HughesPJ 7480005 7550063 3 3 "get1"
    Prelude.True

a823v5v823v72best_doc =
  T.mkVariable tText_PrettyPrint_HughesPJ 8230005 8230072 3 0 "best_doc"
    Prelude.True

a826v5v826v70ribbon_length =
  T.mkVariable tText_PrettyPrint_HughesPJ 8260005 8260070 3 0 "ribbon_length"
    Prelude.True

a827v5v827v84hacked_line_length =
  T.mkVariable tText_PrettyPrint_HughesPJ 8270005 8270084 3 0
    "hacked_line_length" Prelude.True

a833v9v853v42lay =
  T.mkVariable tText_PrettyPrint_HughesPJ 8330009 8530042 3 2 "lay" Prelude.True

a855v9v856v69lay1 =
  T.mkVariable tText_PrettyPrint_HughesPJ 8550009 8560069 3 4 "lay1"
    Prelude.True

a858v9v862v40lay2 =
  T.mkVariable tText_PrettyPrint_HughesPJ 8580009 8620040 3 2 "lay2"
    Prelude.True

a871v5v876v57lay =
  T.mkVariable tText_PrettyPrint_HughesPJ 8710005 8760057 3 2 "lay" Prelude.True
