module Hat.Control.Arrow
  (Arrow(..),Kleisli(Kleisli),aKleisli,greturnA,(!<<<),(+<<<),(*<<<)
    ,ArrowZero(..),ArrowPlus(..),ArrowChoice(..),ArrowApply(..)
    ,ArrowMonad(ArrowMonad),aArrowMonad,gleftApp,aleftApp,hleftApp
    ,ArrowLoop(..)) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Control.Monad 
import Hat.Control.Monad.Fix 

class Arrow a
  where
  
  garr :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun b c) (a b c))
  
  garr parr p = T.uconstUse parr p sarr
  
  sarr = T.uconstDef T.mkRoot a59v9v59v18arr (\ p -> gpure T.mkNoSrcPos p)
  
  gpure :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun b c) (a b c))
  
  gpure ppure p = T.uconstUse ppure p spure
  
  spure = T.uconstDef T.mkRoot a63v9v63v18pure (\ p -> garr T.mkNoSrcPos p)
  
  (!>>>) ::
    T.RefSrcPos -> T.RefExp -> T.R (T.Fun (a b c) (T.Fun (a c d) (a b d)))
  
  gfirst ::
    T.RefSrcPos ->
      T.RefExp -> T.R (T.Fun (a b c) (a (T.Tuple2 b d) (T.Tuple2 c d)))
  
  gsecond ::
    T.RefSrcPos ->
      T.RefExp -> T.R (T.Fun (a b c) (a (T.Tuple2 d b) (T.Tuple2 d c)))
  
  gsecond psecond p =
    T.ufun1 a77v9v78v51second psecond p hsecond
    where
    
    hsecond ff p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
        (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p) (gswap T.mkNoSrcPos p))
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
          (T.uap1 T.mkNoSrcPos p (gfirst T.mkNoSrcPos p) ff)
          (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p) (gswap T.mkNoSrcPos p)))
      where
      
      gswap pswap p = T.ufun1 a78v33v78v51swap pswap p hswap
      
      aswap = a78v33v78v51swap
      
      hswap (T.R ~(T.Tuple2 fx fy) _) p =
        T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (gy T.mkNoSrcPos p)
          (gx T.mkNoSrcPos p)
        where
        
        gx px p = T.uconstUse px p sx
        
        sx = T.uconstDef p a0v0v0v0x (\ p -> T.projection T.mkNoSrcPos p fx)
        
        gy py p = T.uconstUse py p sy
        
        sy = T.uconstDef p a0v0v0v0y (\ p -> T.projection T.mkNoSrcPos p fy)
        
      
    
  
  (!***) ::
    T.RefSrcPos ->
      T.RefExp ->
        T.R
          (T.Fun (a b c) (T.Fun (a b' c') (a (T.Tuple2 b b') (T.Tuple2 c c'))))
  
  (!***) (%***) p =
    T.ufun2 (+@+=##=@+=#%***) (%***) p (****)
    where
    
    (****) ff fg p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
        (T.uap1 T.mkNoSrcPos p (gfirst T.mkNoSrcPos p) ff)
        (T.uap1 T.mkNoSrcPos p (gsecond T.mkNoSrcPos p) fg)
    
  
  (!&&&) ::
    T.RefSrcPos ->
      T.RefExp -> T.R (T.Fun (a b c) (T.Fun (a b c') (a b (T.Tuple2 c c'))))
  
  (!&&&) (%&&&) p =
    T.ufun2 (+>&=##=>&=#%&&&) (%&&&) p (*&&&)
    where
    
    (*&&&) ff fg p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
        (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
          (T.ufun1 T.mkLambda T.mkNoSrcPos p
            (\ fb p -> T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fb fb)))
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !*** p) ff fg)
    
  
  sarr :: T.R (T.Fun (T.Fun b c) (a b c))
  
  spure :: T.R (T.Fun (T.Fun b c) (a b c))
  
  (|>>>) :: T.R (T.Fun (a b c) (T.Fun (a c d) (a b d)))
  
  sfirst :: T.R (T.Fun (a b c) (a (T.Tuple2 b d) (T.Tuple2 c d)))
  
  ssecond :: T.R (T.Fun (a b c) (a (T.Tuple2 d b) (T.Tuple2 d c)))
  
  (|***) ::
    T.R (T.Fun (a b c) (T.Fun (a b' c') (a (T.Tuple2 b b') (T.Tuple2 c c'))))
  
  (|&&&) :: T.R (T.Fun (a b c) (T.Fun (a b c') (a b (T.Tuple2 c c'))))
  

instance Arrow (T.Fun)
  where
  
  garr parr p =
    T.ufun1 a99v9v99v17arr parr p harr
    where
    
    harr ff p = T.projection T.mkNoSrcPos p ff
    
  
  (!>>>) (%>>>) p =
    T.ufun2 (+#!!=##=#!!=#%>>>) (%>>>) p (*>>>)
    where
    
    (*>>>) ff fg p = T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) fg ff
    
  
  gfirst pfirst p =
    T.ufun1 a101v9v101v26first pfirst p hfirst
    where
    
    hfirst ff p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !*** p) ff (gid T.mkNoSrcPos p)
    
  
  gsecond psecond p =
    T.ufun1 a102v9v102v27second psecond p hsecond
    where
    
    hsecond ff p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !*** p) (gid T.mkNoSrcPos p) ff
    
  
  (!***) (%***) p =
    T.ufun3 (+#!%=#!=#!%=%^***) (%***) p (****)
    where
    
    (****) ff fg (T.R ~(T.Tuple2 fx fy) _) p =
      T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
        (T.uap1 T.mkNoSrcPos p ff (gx T.mkNoSrcPos p))
        (T.uap1 T.mkNoSrcPos p fg (gy T.mkNoSrcPos p))
      where
      
      gx px p = T.uconstUse px p sx
      
      sx = T.uconstDef p a0v0v0v0x (\ p -> T.projection T.mkNoSrcPos p fx)
      
      gy py p = T.uconstUse py p sy
      
      sy = T.uconstDef p a0v0v0v0y (\ p -> T.projection T.mkNoSrcPos p fy)
      
    
  

newtype Kleisli m a b = Kleisli (T.R (T.Fun a (m b)))

instance T.WrapVal ((Kleisli m a b))
  where
  
  wrapVal pwrapVal (kwrapVal@(Kleisli (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aKleisli z1wrapVal)
  

instance Monad m => Arrow ((Kleisli m))
  where
  
  garr parr p =
    T.ufun1 a110v9v110v35arr parr p harr
    where
    
    harr ff p =
      T.con1 T.mkNoSrcPos p Kleisli aKleisli
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (greturn T.mkNoSrcPos p) ff)
    
  
  (!>>>) (%>>>) p =
    T.ufun2 (+###=#>=###=$#>>>) (%>>>) p (*>>>)
    where
    
    (*>>>) (T.R (Kleisli ff) _) (T.R (Kleisli fg) _) p =
      T.con1 T.mkNoSrcPos p Kleisli aKleisli
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ fb p ->
            T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>= p)
              (T.uap1 T.mkNoSrcPos p (gf T.mkNoSrcPos p) fb)
              (gg T.mkNoSrcPos p)))
      where
      
      gf pf p = T.uconstUse pf p sf
      
      sf = T.uconstDef p a0v0v0v0f (\ p -> T.projection T.mkNoSrcPos p ff)
      
      gg pg p = T.uconstUse pg p sg
      
      sg = T.uconstDef p a0v0v0v0g (\ p -> T.projection T.mkNoSrcPos p fg)
      
    (*>>>) _ _ p = T.fatal p
    
  
  gfirst pfirst p =
    T.ufun1 a112v9v112v75first pfirst p hfirst
    where
    
    hfirst (T.R (Kleisli ff) _) p =
      T.con1 T.mkNoSrcPos p Kleisli aKleisli
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ (T.R ~(T.Tuple2 fb fd) _) p ->
            let
              gb pb p = T.uconstUse pb p sb
              sb =
                T.uconstDef p a0v0v0v0b (\ p -> T.projection T.mkNoSrcPos p fb)
              gd pd p = T.uconstUse pd p sd
              sd =
                T.uconstDef p a0v0v0v0d (\ p -> T.projection T.mkNoSrcPos p fd)
              in
              (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>= p)
                (T.uap1 T.mkNoSrcPos p (gf T.mkNoSrcPos p) (gb T.mkNoSrcPos p))
                (T.ufun1 T.mkLambda T.mkNoSrcPos p
                  (\ fc p ->
                    T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                      (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fc
                        (gd T.mkNoSrcPos p)))))))
      where
      
      gf pf p = T.uconstUse pf p sf
      
      sf = T.uconstDef p a0v0v0v0f (\ p -> T.projection T.mkNoSrcPos p ff)
      
    hfirst _ p = T.fatal p
    
  
  gsecond psecond p =
    T.ufun1 a113v9v113v76second psecond p hsecond
    where
    
    hsecond (T.R (Kleisli ff) _) p =
      T.con1 T.mkNoSrcPos p Kleisli aKleisli
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ (T.R ~(T.Tuple2 fd fb) _) p ->
            let
              gd pd p = T.uconstUse pd p sd
              sd =
                T.uconstDef p a0v0v0v0d (\ p -> T.projection T.mkNoSrcPos p fd)
              gb pb p = T.uconstUse pb p sb
              sb =
                T.uconstDef p a0v0v0v0b (\ p -> T.projection T.mkNoSrcPos p fb)
              in
              (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>= p)
                (T.uap1 T.mkNoSrcPos p (gf T.mkNoSrcPos p) (gb T.mkNoSrcPos p))
                (T.ufun1 T.mkLambda T.mkNoSrcPos p
                  (\ fc p ->
                    T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                      (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                        (gd T.mkNoSrcPos p) fc))))))
      where
      
      gf pf p = T.uconstUse pf p sf
      
      sf = T.uconstDef p a0v0v0v0f (\ p -> T.projection T.mkNoSrcPos p ff)
      
    hsecond _ p = T.fatal p
    
  

greturnA :: Arrow a => T.RefSrcPos -> T.RefExp -> T.R (a b b)

sreturnA :: Arrow a => T.R (a b b)

greturnA preturnA p = T.uconstUse preturnA p sreturnA

sreturnA =
  T.uconstDef T.mkRoot areturnA
    (\ p -> T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p) (gid T.mkNoSrcPos p))

(!<<<) ::
  Arrow a =>
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (a c d) (T.Fun (a b c) (a b d)))

(*<<<) :: Arrow a => (T.R (a c d)) -> (T.R (a b c)) -> T.RefExp -> T.R (a b d)

(!<<<) (%<<<) p = T.ufun2 (+<<<) (%<<<) p (*<<<)

(*<<<) ff fg p = T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p) fg ff

class Arrow a => ArrowZero a
  where
  
  gzeroArrow :: T.RefSrcPos -> T.RefExp -> T.R (a b c)
  
  szeroArrow :: T.R (a b c)
  

instance MonadPlus m => ArrowZero ((Kleisli m))
  where
  
  gzeroArrow pzeroArrow p = T.uconstUse pzeroArrow p szeroArrow
  
  szeroArrow =
    T.uconstDef T.mkRoot a129v9v129v40zeroArrow
      (\ p ->
        T.con1 T.mkNoSrcPos p Kleisli aKleisli
          (T.ufun1 T.mkLambda T.mkNoSrcPos p (\ fx p -> gmzero T.mkNoSrcPos p)))
  

class ArrowZero a => ArrowPlus a
  where
  
  (!<+>) ::
    T.RefSrcPos -> T.RefExp -> T.R (T.Fun (a b c) (T.Fun (a b c) (a b c)))
  
  (|<+>) :: T.R (T.Fun (a b c) (T.Fun (a b c) (a b c)))
  

instance MonadPlus m => ArrowPlus ((Kleisli m))
  where
  
  (!<+>) (%<+>) p =
    T.ufun2 (+#%*=#>=#%*=$#<+>) (%<+>) p (*<+>)
    where
    
    (*<+>) (T.R (Kleisli ff) _) (T.R (Kleisli fg) _) p =
      T.con1 T.mkNoSrcPos p Kleisli aKleisli
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ fx p ->
            T.uap2 T.mkNoSrcPos p (gmplus T.mkNoSrcPos p)
              (T.uap1 T.mkNoSrcPos p (gf T.mkNoSrcPos p) fx)
              (T.uap1 T.mkNoSrcPos p (gg T.mkNoSrcPos p) fx)))
      where
      
      gf pf p = T.uconstUse pf p sf
      
      sf = T.uconstDef p a0v0v0v0f (\ p -> T.projection T.mkNoSrcPos p ff)
      
      gg pg p = T.uconstUse pg p sg
      
      sg = T.uconstDef p a0v0v0v0g (\ p -> T.projection T.mkNoSrcPos p fg)
      
    (*<+>) _ _ p = T.fatal p
    
  

class Arrow a => ArrowChoice a
  where
  
  gleft ::
    T.RefSrcPos -> T.RefExp -> T.R (T.Fun (a b c) (a (Either b d) (Either c d)))
  
  gright ::
    T.RefSrcPos -> T.RefExp -> T.R (T.Fun (a b c) (a (Either d b) (Either d c)))
  
  gright pright p =
    T.ufun1 a153v9v155v57right pright p hright
    where
    
    hright ff p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
        (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p) (gmirror T.mkNoSrcPos p))
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
          (T.uap1 T.mkNoSrcPos p (gleft T.mkNoSrcPos p) ff)
          (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
            (gmirror T.mkNoSrcPos p)))
      where
      
      gmirror pmirror p = T.ufun1 a154v33v155v57mirror pmirror p hmirror
      
      amirror = a154v33v155v57mirror
      
      hmirror (T.R (Left fx) _) p = T.con1 T.mkNoSrcPos p Right aRight fx
      hmirror (T.R (Right fy) _) p = T.con1 T.mkNoSrcPos p Left aLeft fy
      hmirror _ p = T.fatal p
      
    
  
  (!+++) ::
    T.RefSrcPos ->
      T.RefExp ->
        T.R (T.Fun (a b c) (T.Fun (a b' c') (a (Either b b') (Either c c'))))
  
  (!+++) (%+++) p =
    T.ufun2 (+#+&=##=#+&=#%+++) (%+++) p (*+++)
    where
    
    (*+++) ff fg p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
        (T.uap1 T.mkNoSrcPos p (gleft T.mkNoSrcPos p) ff)
        (T.uap1 T.mkNoSrcPos p (gright T.mkNoSrcPos p) fg)
    
  
  (!|||) ::
    T.RefSrcPos ->
      T.RefExp -> T.R (T.Fun (a b d) (T.Fun (a c d) (a (Either b c) d)))
  
  (!|||) (%|||) p =
    T.ufun2 (+#^$=##=#^$=#%|||) (%|||) p (*|||)
    where
    
    (*|||) ff fg p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+++ p) ff fg)
        (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p) (guntag T.mkNoSrcPos p))
      where
      
      guntag puntag p = T.ufun1 a173v33v174v51untag puntag p huntag
      
      auntag = a173v33v174v51untag
      
      huntag (T.R (Left fx) _) p = T.projection T.mkNoSrcPos p fx
      huntag (T.R (Right fy) _) p = T.projection T.mkNoSrcPos p fy
      huntag _ p = T.fatal p
      
    
  
  sleft :: T.R (T.Fun (a b c) (a (Either b d) (Either c d)))
  
  sright :: T.R (T.Fun (a b c) (a (Either d b) (Either d c)))
  
  (|+++) ::
    T.R (T.Fun (a b c) (T.Fun (a b' c') (a (Either b b') (Either c c'))))
  
  (||||) :: T.R (T.Fun (a b d) (T.Fun (a c d) (a (Either b c) d)))
  

instance ArrowChoice (T.Fun)
  where
  
  gleft pleft p =
    T.ufun1 a177v9v177v25left pleft p hleft
    where
    
    hleft ff p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+++ p) ff (gid T.mkNoSrcPos p)
    
  
  gright pright p =
    T.ufun1 a178v9v178v26right pright p hright
    where
    
    hright ff p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+++ p) (gid T.mkNoSrcPos p) ff
    
  
  (!+++) (%+++) p =
    T.ufun2 (+#^>=##=#^>=#%+++) (%+++) p (*+++)
    where
    
    (*+++) ff fg p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !||| p)
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.pa0 Left T.cn1 T.mkNoSrcPos p aLeft) ff)
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.pa0 Right T.cn1 T.mkNoSrcPos p aRight) fg)
    
  
  (!|||) (%|||) p = T.uconstUse (%|||) p (||||)
  
  (||||) =
    T.uconstDef T.mkRoot (+#@!=#!=#@!=$$|||) (\ p -> geither T.mkNoSrcPos p)
  

instance Monad m => ArrowChoice ((Kleisli m))
  where
  
  gleft pleft p =
    T.ufun1 a183v9v183v29left pleft p hleft
    where
    
    hleft ff p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+++ p) ff
        (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p) (gid T.mkNoSrcPos p))
    
  
  gright pright p =
    T.ufun1 a184v9v184v30right pright p hright
    where
    
    hright ff p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+++ p)
        (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p) (gid T.mkNoSrcPos p)) ff
    
  
  (!+++) (%+++) p =
    T.ufun2 (+#@*=##=#@*=#%+++) (%+++) p (*+++)
    where
    
    (*+++) ff fg p =
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !||| p)
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p) ff
          (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
            (T.pa0 Left T.cn1 T.mkNoSrcPos p aLeft)))
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p) fg
          (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
            (T.pa0 Right T.cn1 T.mkNoSrcPos p aRight)))
    
  
  (!|||) (%|||) p =
    T.ufun2 (+#@+=#>=#@+=$#|||) (%|||) p (*|||)
    where
    
    (*|||) (T.R (Kleisli ff) _) (T.R (Kleisli fg) _) p =
      T.con1 T.mkNoSrcPos p Kleisli aKleisli
        (T.uap2 T.mkNoSrcPos p (geither T.mkNoSrcPos p) (gf T.mkNoSrcPos p)
          (gg T.mkNoSrcPos p))
      where
      
      gf pf p = T.uconstUse pf p sf
      
      sf = T.uconstDef p a0v0v0v0f (\ p -> T.projection T.mkNoSrcPos p ff)
      
      gg pg p = T.uconstUse pg p sg
      
      sg = T.uconstDef p a0v0v0v0g (\ p -> T.projection T.mkNoSrcPos p fg)
      
    (*|||) _ _ p = T.fatal p
    
  

class Arrow a => ArrowApply a
  where
  
  gapp :: T.RefSrcPos -> T.RefExp -> T.R (a (T.Tuple2 (a b c) b) c)
  
  sapp :: T.R (a (T.Tuple2 (a b c) b) c)
  

instance ArrowApply (T.Fun)
  where
  
  gapp papp p =
    T.ufun1 a194v9v194v23app papp p happ
    where
    
    happ (T.R (T.Tuple2 ff fx) _) p = T.uap1 T.mkNoSrcPos p ff fx
    happ _ p = T.fatal p
    
  

instance Monad m => ArrowApply ((Kleisli m))
  where
  
  gapp papp p = T.uconstUse papp p sapp
  
  sapp =
    T.uconstDef T.mkRoot a197v9v197v45app
      (\ p ->
        T.con1 T.mkNoSrcPos p Kleisli aKleisli
          (T.ufun1 T.mkLambda T.mkNoSrcPos p
            (\ v197v24v197v45v1 p ->
              case (v197v24v197v45v1) of
                (T.R (T.Tuple2 (T.R (Kleisli ff) _) fx) _) ->
                  let
                    gf pf p = T.uconstUse pf p sf
                    sf =
                      T.uconstDef p a0v0v0v0f
                        (\ p -> T.projection T.mkNoSrcPos p ff) in
                    (T.uap1 T.mkNoSrcPos p (gf T.mkNoSrcPos p) fx)
                _ -> T.fatal p)))
  

newtype ArrowApply a => ArrowMonad a b = ArrowMonad (T.R (a T.Tuple0 b))

instance ArrowApply a => T.WrapVal ((ArrowMonad a b))
  where
  
  wrapVal pwrapVal (kwrapVal@(ArrowMonad (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aArrowMonad z1wrapVal)
  

instance ArrowApply a => Monad ((ArrowMonad a))
  where
  
  greturn preturn p =
    T.ufun1 a205v9v205v43return preturn p hreturn
    where
    
    hreturn fx p =
      T.con1 T.mkNoSrcPos p ArrowMonad aArrowMonad
        (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
          (T.ufun1 T.mkLambda T.mkNoSrcPos p
            (\ fz p -> T.projection T.mkNoSrcPos p fx)))
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+$!+=$$=$!+=$&>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) (T.R (ArrowMonad fm) _) ff p =
      T.con1 T.mkNoSrcPos p ArrowMonad aArrowMonad
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p) (gm T.mkNoSrcPos p)
          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
            (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                (\ fx p ->
                  let
                    gh ph p = T.uconstUse ph p sh
                    j207v40v207v51h =
                      case T.uap1 T.mkNoSrcPos p ff fx of
                        T.R (ArrowMonad fh) kh -> (kh,fh)
                        _ -> T.fatal p
                    sh =
                      T.uconstDef p a207v51v207v51h
                        (\ _ -> case j207v40v207v51h of (kh,fh) -> fh) in
                    (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                      (gh T.mkNoSrcPos p)
                      (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0)))))
            (gapp T.mkNoSrcPos p)))
      where
      
      gm pm p = T.uconstUse pm p sm
      
      sm = T.uconstDef p a0v0v0v0m (\ p -> T.projection T.mkNoSrcPos p fm)
      
    (*>>=) _ _ p = T.fatal p
    
  

gleftApp ::
  ArrowApply a =>
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (a b c) (a (Either b d) (Either c d)))

hleftApp ::
  ArrowApply a => (T.R (a b c)) -> T.RefExp -> T.R (a (Either b d) (Either c d))

gleftApp pleftApp p = T.ufun1 aleftApp pleftApp p hleftApp

hleftApp ff p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
    (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
      (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !||| p)
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ fb p ->
            T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
              (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
                (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ v214v31v214v39v1 p ->
                      case (v214v31v214v39v1) of
                        (T.R T.Tuple0 _) -> T.projection T.mkNoSrcPos p fb
                        _ -> T.fatal p)))
                (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p) ff
                  (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
                    (T.pa0 Left T.cn1 T.mkNoSrcPos p aLeft))))
              (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0)))
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ fd p ->
            T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
              (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>>> p)
                (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ v215v31v215v39v1 p ->
                      case (v215v31v215v39v1) of
                        (T.R T.Tuple0 _) -> T.projection T.mkNoSrcPos p fd
                        _ -> T.fatal p)))
                (T.uap1 T.mkNoSrcPos p (garr T.mkNoSrcPos p)
                  (T.pa0 Right T.cn1 T.mkNoSrcPos p aRight)))
              (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0)))))
    (gapp T.mkNoSrcPos p)

class Arrow a => ArrowLoop a
  where
  
  gloop ::
    T.RefSrcPos ->
      T.RefExp -> T.R (T.Fun (a (T.Tuple2 b d) (T.Tuple2 c d)) (a b c))
  
  sloop :: T.R (T.Fun (a (T.Tuple2 b d) (T.Tuple2 c d)) (a b c))
  

instance ArrowLoop (T.Fun)
  where
  
  gloop ploop p =
    T.ufun2 a225v9v225v43loop ploop p hloop
    where
    
    hloop ff fb p =
      let
        gc pc p = T.uconstUse pc p sc
        gd pc p = T.uconstUse pc p sd
        j225v24v225v28c =
          case
            T.uap1 T.mkNoSrcPos p ff
              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fb
                (gd T.mkNoSrcPos p)) of
            T.R (T.Tuple2 fc fd) kc -> (kc,fc,fd)
            _ -> T.fatal p
        sc =
          T.uconstDef p a225v25v225v25c
            (\ _ -> case j225v24v225v28c of (kc,fc,fd) -> fc)
        sd =
          T.uconstDef p a225v27v225v27d
            (\ _ -> case j225v24v225v28c of (kc,fc,fd) -> fd) in
        (gc T.mkNoSrcPos p)
    
  

instance MonadFix m => ArrowLoop ((Kleisli m))
  where
  
  gloop ploop p =
    T.ufun1 a228v9v229v45loop ploop p hloop
    where
    
    hloop (T.R (Kleisli ff) _) p =
      T.con1 T.mkNoSrcPos p Kleisli aKleisli
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.uwrapForward p (hliftM (gfst T.mkNoSrcPos p) p))
          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (gmfix T.mkNoSrcPos p)
            (gf' T.mkNoSrcPos p)))
      where
      
      gf pf p = T.uconstUse pf p sf
      
      sf = T.uconstDef p a0v0v0v0f (\ p -> T.projection T.mkNoSrcPos p ff)
      
      gf' pf' p = T.ufun2 a229v25v229v45f' pf' p hf'
      
      af' = a229v25v229v45f'
      
      hf' fx fy p =
        T.uap1 T.mkNoSrcPos p (gf T.mkNoSrcPos p)
          (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fx
            (T.uwrapForward p (hsnd fy p)))
      
    hloop _ p = T.fatal p
    
  

tControl_Arrow = T.mkModule "Control.Arrow" "Control/Arrow.hs" Prelude.False

aKleisli = T.mkConstructor tControl_Arrow 1070025 1070031 3 1 "Kleisli"

aArrowMonad = T.mkConstructor tControl_Arrow 2020042 2020051 3 1 "ArrowMonad"

a59v9v59v18arr =
  T.mkVariable tControl_Arrow 590009 590018 3 0 "arr" Prelude.False

a63v9v63v18pure =
  T.mkVariable tControl_Arrow 630009 630018 3 0 "pure" Prelude.False

a77v9v78v51second =
  T.mkVariable tControl_Arrow 770009 780051 3 1 "second" Prelude.False

(+@+=##=@+=#%***) =
  T.mkVariable tControl_Arrow 860011 860013 13 2 "***" Prelude.False

(+>&=##=>&=#%&&&) =
  T.mkVariable tControl_Arrow 940011 940013 13 2 "&&&" Prelude.False

a99v9v99v17arr =
  T.mkVariable tControl_Arrow 990009 990017 3 1 "arr" Prelude.False

(+#!!=##=#!!=#%>>>) =
  T.mkVariable tControl_Arrow 1000011 1000013 5 2 ">>>" Prelude.False

a101v9v101v26first =
  T.mkVariable tControl_Arrow 1010009 1010026 3 1 "first" Prelude.False

a102v9v102v27second =
  T.mkVariable tControl_Arrow 1020009 1020027 3 1 "second" Prelude.False

(+#!%=#!=#!%=%^***) =
  T.mkVariable tControl_Arrow 1030010 1030037 13 3 "***" Prelude.False

a110v9v110v35arr =
  T.mkVariable tControl_Arrow 1100009 1100035 3 1 "arr" Prelude.False

(+###=#>=###=$#>>>) =
  T.mkVariable tControl_Arrow 1110019 1110021 5 2 ">>>" Prelude.False

a112v9v112v75first =
  T.mkVariable tControl_Arrow 1120009 1120075 3 1 "first" Prelude.False

a113v9v113v76second =
  T.mkVariable tControl_Arrow 1130009 1130076 3 1 "second" Prelude.False

areturnA =
  T.mkVariable tControl_Arrow 1180001 1180016 3 0 "returnA" Prelude.False

(+<<<) = T.mkVariable tControl_Arrow 1230003 1230005 5 2 "<<<" Prelude.False

a129v9v129v40zeroArrow =
  T.mkVariable tControl_Arrow 1290009 1290040 3 0 "zeroArrow" Prelude.False

(+#%*=#>=#%*=$#<+>) =
  T.mkVariable tControl_Arrow 1350019 1350021 21 2 "<+>" Prelude.False

a153v9v155v57right =
  T.mkVariable tControl_Arrow 1530009 1550057 3 1 "right" Prelude.False

(+#+&=##=#+&=#%+++) =
  T.mkVariable tControl_Arrow 1640011 1640013 9 2 "+++" Prelude.False

(+#^$=##=#^$=#%|||) =
  T.mkVariable tControl_Arrow 1720011 1720013 9 2 "|||" Prelude.False

a177v9v177v25left =
  T.mkVariable tControl_Arrow 1770009 1770025 3 1 "left" Prelude.False

a178v9v178v26right =
  T.mkVariable tControl_Arrow 1780009 1780026 3 1 "right" Prelude.False

(+#^>=##=#^>=#%+++) =
  T.mkVariable tControl_Arrow 1790011 1790013 9 2 "+++" Prelude.False

(+#@!=#!=#@!=$$|||) =
  T.mkVariable tControl_Arrow 1800010 1800022 9 0 "|||" Prelude.False

a183v9v183v29left =
  T.mkVariable tControl_Arrow 1830009 1830029 3 1 "left" Prelude.False

a184v9v184v30right =
  T.mkVariable tControl_Arrow 1840009 1840030 3 1 "right" Prelude.False

(+#@*=##=#@*=#%+++) =
  T.mkVariable tControl_Arrow 1850011 1850013 9 2 "+++" Prelude.False

(+#@+=#>=#@+=$#|||) =
  T.mkVariable tControl_Arrow 1860019 1860021 9 2 "|||" Prelude.False

a194v9v194v23app =
  T.mkVariable tControl_Arrow 1940009 1940023 3 1 "app" Prelude.False

a197v9v197v45app =
  T.mkVariable tControl_Arrow 1970009 1970045 3 0 "app" Prelude.False

a205v9v205v43return =
  T.mkVariable tControl_Arrow 2050009 2050043 3 1 "return" Prelude.False

(+$!+=$$=$!+=$&>>=) =
  T.mkVariable tControl_Arrow 2060022 2060024 6 2 ">>=" Prelude.False

aleftApp =
  T.mkVariable tControl_Arrow 2140001 2150070 3 1 "leftApp" Prelude.False

a225v9v225v43loop =
  T.mkVariable tControl_Arrow 2250009 2250043 3 2 "loop" Prelude.False

a228v9v229v45loop =
  T.mkVariable tControl_Arrow 2280009 2290045 3 1 "loop" Prelude.False

a78v33v78v51swap =
  T.mkVariable tControl_Arrow 780033 780051 3 1 "swap" Prelude.True

a0v0v0v0x = T.mkVariable tControl_Arrow 0 0 3 0 "x" Prelude.True

a0v0v0v0y = T.mkVariable tControl_Arrow 0 0 3 0 "y" Prelude.True

a0v0v0v0f = T.mkVariable tControl_Arrow 0 0 3 0 "f" Prelude.True

a0v0v0v0g = T.mkVariable tControl_Arrow 0 0 3 0 "g" Prelude.True

a0v0v0v0b = T.mkVariable tControl_Arrow 0 0 3 0 "b" Prelude.True

a0v0v0v0d = T.mkVariable tControl_Arrow 0 0 3 0 "d" Prelude.True

a154v33v155v57mirror =
  T.mkVariable tControl_Arrow 1540033 1550057 3 1 "mirror" Prelude.True

a173v33v174v51untag =
  T.mkVariable tControl_Arrow 1730033 1740051 3 1 "untag" Prelude.True

a0v0v0v0m = T.mkVariable tControl_Arrow 0 0 3 0 "m" Prelude.True

a207v51v207v51h =
  T.mkVariable tControl_Arrow 2070051 2070051 3 0 "h" Prelude.True

a225v25v225v25c =
  T.mkVariable tControl_Arrow 2250025 2250025 3 0 "c" Prelude.True

a225v27v225v27d =
  T.mkVariable tControl_Arrow 2250027 2250027 3 0 "d" Prelude.True

a229v25v229v45f' =
  T.mkVariable tControl_Arrow 2290025 2290045 3 2 "f'" Prelude.True
