module Hat.Control.Monad.Identity
  (Identity(Identity,brunIdentity),aIdentity,grunIdentity,hrunIdentity
    ,arunIdentity,module Hat.Control.Monad,module Hat.Control.Monad.Fix) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Control.Monad 
import Hat.Control.Monad.Fix 

newtype Identity a = Identity {brunIdentity :: T.R a}

instance T.WrapVal ((Identity a))
  where
  
  wrapVal pwrapVal (kwrapVal@(Identity (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aIdentity z1wrapVal)
  

grunIdentity prunIdentity p = T.ufun1 arunIdentity prunIdentity p hrunIdentity

hrunIdentity (T.R z1runIdentity _) p =
  T.projection T.mkNoSrcPos p (brunIdentity z1runIdentity)

instance Functor (Identity)
  where
  
  gfmap pfmap p =
    T.ufun2 a53v9v53v45fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.con1 T.mkNoSrcPos p Identity aIdentity
        (T.uap1 T.mkNoSrcPos p ff (T.uwrapForward p (hrunIdentity fm p)))
    
  

instance Monad (Identity)
  where
  
  greturn preturn p =
    T.ufun1 a56v9v56v29return preturn p hreturn
    where
    
    hreturn fa p = T.con1 T.mkNoSrcPos p Identity aIdentity fa
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+*^=##=*^=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uap1 T.mkNoSrcPos p fk (T.uwrapForward p (hrunIdentity fm p))
    
  

instance MonadFix (Identity)
  where
  
  gmfix pmfix p =
    T.ufun1 a60v9v60v47mfix pmfix p hmfix
    where
    
    hmfix ff p =
      T.con1 T.mkNoSrcPos p Identity aIdentity
        (T.uwrapForward p
          (hfix
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
              (grunIdentity T.mkNoSrcPos p) ff) p))
    
  

tControl_Monad_Identity =
  T.mkModule "Control.Monad.Identity" "Control/Monad/Identity.hs" Prelude.False

aIdentity =
  T.mkConstructorWFields tControl_Monad_Identity 470022 470029 3 1 "Identity"
    (arunIdentity : [])

arunIdentity =
  T.mkVariable tControl_Monad_Identity 470033 470043 3 1 "runIdentity"
    Prelude.False

a53v9v53v45fmap =
  T.mkVariable tControl_Monad_Identity 530009 530045 3 2 "fmap" Prelude.False

a56v9v56v29return =
  T.mkVariable tControl_Monad_Identity 560009 560029 3 1 "return" Prelude.False

(+*^=##=*^=#%>>=) =
  T.mkVariable tControl_Monad_Identity 570011 570013 6 2 ">>=" Prelude.False

a60v9v60v47mfix =
  T.mkVariable tControl_Monad_Identity 600009 600047 3 1 "mfix" Prelude.False
