module Hat.Control.Monad.List
  (ListT(ListT,brunListT),aListT,grunListT,hrunListT,arunListT,gmapListT
    ,amapListT,hmapListT,module Hat.Control.Monad
    ,module Hat.Control.Monad.Trans) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Control.Monad 
import Hat.Control.Monad.Trans 
import Hat.Control.Monad.Reader 
import Hat.Control.Monad.State 
import Hat.Control.Monad.Cont 
import Hat.Control.Monad.Error 

newtype ListT m a = ListT {brunListT :: T.R (m (T.List a))}

instance T.WrapVal ((ListT m a))
  where
  
  wrapVal pwrapVal (kwrapVal@(ListT (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aListT z1wrapVal)
  

grunListT prunListT p = T.ufun1 arunListT prunListT p hrunListT

hrunListT (T.R z1runListT _) p =
  T.projection T.mkNoSrcPos p (brunListT z1runListT)

instance Monad m => Functor ((ListT m))
  where
  
  gfmap pfmap p =
    T.ufun2 a38v9v40v31fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunListT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fa p ->
                  T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                    (T.uwrapForward p (hmap ff fa p)))))) p)
    
  

instance Monad m => Monad ((ListT m))
  where
  
  greturn preturn p =
    T.ufun1 a43v9v43v37return preturn p hreturn
    where
    
    hreturn fa p =
      T.uwrapForward p
        (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
            *$
            (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.fromExpList T.mkNoSrcPos p [fa]))) p)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+&&=##=&&=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunListT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fa p ->
                  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                    (T.uwrapForward p
                      (hmapM
                        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
                          (grunListT T.mkNoSrcPos p) fk) fa p))
                    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                      (\ fb p ->
                        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                          (T.uwrapForward p (hconcat fb p)))))))) p)
    
  
  gfail pfail p =
    T.ufun1 a48v9v48v34fail pfail p hfail
    where
    
    hfail _ p =
      T.uwrapForward p
        (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
            *$
            (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.con0 T.mkNoSrcPos p T.List T.aList))) p)
    
  

instance Monad m => MonadPlus ((ListT m))
  where
  
  gmzero pmzero p = T.uconstUse pmzero p smzero
  
  smzero =
    T.uconstDef T.mkRoot a51v9v51v39mzero
      (\ p ->
        T.uwrapForward p
          (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
              *$
              (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                (T.con0 T.mkNoSrcPos p T.List T.aList))) p))
  
  gmplus pmplus p =
    T.ufun2 a52v12v52v16mplus pmplus p hmplus
    where
    
    hmplus fm fn p =
      T.uwrapForward p
        (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunListT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fa p ->
                  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                    (T.uwrapForward p (hrunListT fn p))
                    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                      (\ fb p ->
                        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                          (T.uwrapForward p ((fa *++ fb) p)))))))) p)
    
  

instance MonadTrans (ListT)
  where
  
  glift plift p =
    T.ufun1 a58v9v60v26lift plift p hlift
    where
    
    hlift fm p =
      T.uwrapForward p
        (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fm
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fa p ->
                  T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                    (T.fromExpList T.mkNoSrcPos p [fa]))))) p)
    
  

instance MonadIO m => MonadIO ((ListT m))
  where
  
  gliftIO pliftIO p = T.uconstUse pliftIO p sliftIO
  
  sliftIO =
    T.uconstDef T.mkRoot a63v9v63v30liftIO
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gliftIO T.mkNoSrcPos p))
  

instance MonadReader s m => MonadReader (s) ((ListT m))
  where
  
  gask pask p = T.uconstUse pask p sask
  
  sask =
    T.uconstDef T.mkRoot a66v9v66v28ask
      (\ p ->
        T.uap1 T.mkNoSrcPos p (glift T.mkNoSrcPos p) (gask T.mkNoSrcPos p))
  
  glocal plocal p =
    T.ufun2 a67v9v67v47local plocal p hlocal
    where
    
    hlocal ff fm p =
      T.uwrapForward p
        (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
            *$
            (T.uap2 T.mkNoSrcPos p (glocal T.mkNoSrcPos p) ff
              (T.uwrapForward p (hrunListT fm p)))) p)
    
  

instance MonadState s m => MonadState (s) ((ListT m))
  where
  
  gget pget p = T.uconstUse pget p sget
  
  sget =
    T.uconstDef T.mkRoot a70v9v70v22get
      (\ p ->
        T.uap1 T.mkNoSrcPos p (glift T.mkNoSrcPos p) (gget T.mkNoSrcPos p))
  
  gput pput p = T.uconstUse pput p sput
  
  sput =
    T.uconstDef T.mkRoot a71v9v71v24put
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gput T.mkNoSrcPos p))
  

instance MonadCont m => MonadCont ((ListT m))
  where
  
  gcallCC pcallCC p =
    T.ufun1 a74v9v76v48callCC pcallCC p hcallCC
    where
    
    hcallCC ff p =
      T.uwrapForward p
        (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
            *$
            (T.uwrapForward p
              (((gcallCC T.mkNoSrcPos p)
                  *$
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ fc p ->
                      T.uwrapForward p
                        (hrunListT
                          (T.uap1 T.mkNoSrcPos p ff
                            (T.ufun1 T.mkLambda T.mkNoSrcPos p
                              (\ fa p ->
                                T.uwrapForward p
                                  (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
                                      *$
                                      (T.uap1 T.mkNoSrcPos p fc
                                        (T.fromExpList T.mkNoSrcPos p [fa])))
                                    p)))) p)))) p))) p)
    
  

instance MonadError e m => MonadError (e) ((ListT m))
  where
  
  gthrowError pthrowError p = T.uconstUse pthrowError p sthrowError
  
  sthrowError =
    T.uconstDef T.mkRoot a79v9v79v44throwError
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gthrowError T.mkNoSrcPos p))
  
  gcatchError pcatchError p =
    T.ufun2 a80v12v80v21catchError pcatchError p hcatchError
    where
    
    hcatchError fm fh p =
      T.uwrapForward p
        (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
            *$
            (T.uap2 T.mkNoSrcPos p (gcatchError T.mkNoSrcPos p)
              (T.uwrapForward p (hrunListT fm p))
              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                (\ fe p ->
                  T.uwrapForward p
                    (hrunListT (T.uap1 T.mkNoSrcPos p fh fe) p))))) p)
    
  

gmapListT ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (m (T.List a)) (n (T.List b)))
          (T.Fun (ListT m a) (ListT n b)))

hmapListT ::
  (T.R (T.Fun (m (T.List a)) (n (T.List b)))) ->
    (T.R (ListT m a)) -> T.RefExp -> T.R (ListT n b)

gmapListT pmapListT p = T.ufun2 amapListT pmapListT p hmapListT

hmapListT ff fm p =
  T.uwrapForward p
    (((T.pa0 ListT T.cn1 T.mkNoSrcPos p aListT)
        *$
        (T.uap1 T.mkNoSrcPos p ff (T.uwrapForward p (hrunListT fm p)))) p)

tControl_Monad_List =
  T.mkModule "Control.Monad.List" "Control/Monad/List.hs" Prelude.False

aListT =
  T.mkConstructorWFields tControl_Monad_List 350021 350025 3 1 "ListT"
    (arunListT : [])

arunListT =
  T.mkVariable tControl_Monad_List 350029 350036 3 1 "runListT" Prelude.False

a38v9v40v31fmap =
  T.mkVariable tControl_Monad_List 380009 400031 3 2 "fmap" Prelude.False

a43v9v43v37return =
  T.mkVariable tControl_Monad_List 430009 430037 3 1 "return" Prelude.False

(+&&=##=&&=#%>>=) =
  T.mkVariable tControl_Monad_List 440011 440013 6 2 ">>=" Prelude.False

a48v9v48v34fail =
  T.mkVariable tControl_Monad_List 480009 480034 3 1 "fail" Prelude.False

a51v9v51v39mzero =
  T.mkVariable tControl_Monad_List 510009 510039 3 0 "mzero" Prelude.False

a52v12v52v16mplus =
  T.mkVariable tControl_Monad_List 520012 520016 3 2 "mplus" Prelude.False

a58v9v60v26lift =
  T.mkVariable tControl_Monad_List 580009 600026 3 1 "lift" Prelude.False

a63v9v63v30liftIO =
  T.mkVariable tControl_Monad_List 630009 630030 3 0 "liftIO" Prelude.False

a66v9v66v28ask =
  T.mkVariable tControl_Monad_List 660009 660028 3 0 "ask" Prelude.False

a67v9v67v47local =
  T.mkVariable tControl_Monad_List 670009 670047 3 2 "local" Prelude.False

a70v9v70v22get =
  T.mkVariable tControl_Monad_List 700009 700022 3 0 "get" Prelude.False

a71v9v71v24put =
  T.mkVariable tControl_Monad_List 710009 710024 3 0 "put" Prelude.False

a74v9v76v48callCC =
  T.mkVariable tControl_Monad_List 740009 760048 3 1 "callCC" Prelude.False

a79v9v79v44throwError =
  T.mkVariable tControl_Monad_List 790009 790044 3 0 "throwError" Prelude.False

a80v12v80v21catchError =
  T.mkVariable tControl_Monad_List 800012 800021 3 2 "catchError" Prelude.False

amapListT =
  T.mkVariable tControl_Monad_List 840001 840036 3 2 "mapListT" Prelude.False
