module Hat.Debug.Trace (gtrace,atrace,htrace) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.PreludeBuiltinTypes 
import qualified Debug.Trace 

gtrace :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun String (T.Fun a a))

gtrace ptrace p = T.ufun2 atrace ptrace p htrace

htrace z1trace z2trace ktrace =
  T.fromId ktrace
    (Debug.Trace.trace (toString ktrace z1trace) (T.toId ktrace z2trace))

tDebug_Trace = T.mkModule "Debug.Trace" "Debug/Trace.hs" Prelude.False

atrace = T.mkVariable tDebug_Trace 80001 80068 3 2 "trace" Prelude.False
